// ALISP engine v0.4.3b
// ALISP is dedicated to Enota, the girl i'll never forget
// coded by Ketmar // Vampire Avalon (psyc://ketmar.no-ip.org/~Ketmar)
// Understanding is not required. Only obedience.
//
// This program is free software. It comes without any warranty, to
// the extent permitted by applicable law. You can redistribute it
// and/or modify it under the terms of the Do What The Fuck You Want
// To Public License, Version 2, as published by Sam Hocevar. See
// http://sam.zoy.org/wtfpl/COPYING for more details.
//

{ TSortedIntList }
destructor TSortedIntList.Destroy ();
begin
  Clear();
end;

procedure TSortedIntList.Clear ();
begin
  fCount := 0; SetCapacity(0);
end;

procedure TSortedIntList.Insert (index, item: Integer);
begin
  if (index < 0) or (index > fCount) then
    raise EListError.Create('list index out of bounds ('+IntToStr(index)+')');
  if fCount = fCapacity then Grow();
  if index < fCount then
    System.Move(fList^[index], fList^[index+1], (fCount-index)*SizeOf(Integer));
  fList^[index] := item;
  Inc(fCount);
end;

function TSortedIntList.Add (item: Integer): Integer;
begin
  if not Find(item, result) then Insert(result, item);
end;

procedure TSortedIntList.Delete (index: Integer);
begin
  if (index < 0) or (index >= fCount) then
    raise EListError.Create('list index out of bounds ('+IntToStr(index)+')');
  Dec(fCount);
  if index < fCount then
    System.Move(fList^[index+1], fList^[index], (fCount-index)*SizeOf(Integer));
end;

function TSortedIntList.Get (index: Integer): Integer;
begin
  if (index < 0) or (index >= fCount) then
    raise EListError.Create('list index out of bounds ('+IntToStr(index)+')');
  result := fList^[index];
end;

procedure TSortedIntList.Grow ();
var
  delta: Integer;
begin
  if fCapacity > 64 then delta := fCapacity div 4
  else if fCapacity > 8 then delta := 16
  else delta := 4;
  SetCapacity(fCapacity+delta);
end;

function TSortedIntList.IndexOf (item: Integer): Integer;
begin
  if not Find(item, result) then result := -1;
end;

procedure TSortedIntList.SetCapacity (newCapacity: Integer);
begin
  if (newCapacity < fCount) or (newCapacity > maxListSize) then
    raise EListError.Create('invalid new list capacity ('+IntToStr(newCapacity)+')');
  if newCapacity <> fCapacity then
  begin
    ReallocMem(fList, newCapacity*SizeOf(Integer));
    fCapacity := newCapacity;
  end;
end;

function TSortedIntList.Extract (item: Integer): Integer;
var
  f: Integer;
begin
  result := 0;
  if Find(item, f) then
  begin
    result := item;
    Delete(f);
  end;
end;

function TSortedIntList.Find (item: Integer; out index: Integer): Boolean;
var
  l, h, i, c: Integer;
begin
  result := false;
  l := 0; h := fCount-1;
  while l <= h do
  begin
    i := (l+h) shr 1;
    c := fList^[i]-item;//CompareStrings(fList^[i].FString, S);
    if c < 0 then l := i+1
    else
    begin
      h := i-1;
      if c = 0 then
      begin
        result := true;
        {if Duplicates <> dupAccept then} l := i;
      end;
    end;
  end;
  index := l;
end;
