// DarkSpecter ZX Spectum Emulator
// coded by Ketmar // Vampire Avalon (psyc://ketmar.no-ip.org/~Ketmar)
// Understanding is not required. Only obedience.
//
// This program is free software. It comes without any warranty, to
// the extent permitted by applicable law. You can redistribute it
// and/or modify it under the terms of the Do What The Fuck You Want
// To Public License, Version 2, as published by Sam Hocevar. See
// http://sam.zoy.org/wtfpl/COPYING for more details.
//
{.$APPTYPE CONSOLE}
{.$DEFINE SHOWCPUSPEED}
{.$DEFINE WRITE_MESSAGES}
{$APPTYPE GUI}
{$INCLUDE options.inc}
program dsp;

uses
  dspConDriverU in 'syslow\dspConDriverU.pas',
  dspXInitU in 'dspXInitU.pas',
  Windows, Messages, SysUtils, Classes,
  dspUtilsU in 'dspUtilsU.pas',
  {$IFDEF WRITE_MESSAGES}
  wmsgU in 'syslow\wmsgU.pas',
  {$ENDIF}
  win32U in 'syslow\win32U.pas',
  ActiveX,
  DirectDraw7 in 'syslow\DirectDraw7.pas',
  z80U in 'z80\z80U.pas',

  {$IFDEF USE_HP_TIMER}
  hpTimerU in 'syslow\hpTimerU.pas',
  {$ELSE}
  cpuSpeedU in 'syslow\cpuSpeedU.pas',
  qCounterU in 'syslow\qCounterU.pas',
  {$ENDIF}

  xpackU in 'xpack\xpackU.pas',
  wpackU in 'xpack\wpackU.pas',
  wdxpackU in 'xpack\wdxpackU.pas',
  md5U in 'xpack\md5U.pas',
  alisp3U in 'alisp3\alisp3U.pas',
  alisp3FilesU in 'alisp3\alisp3FilesU.pas',
  RegExprU in 'miscU\RegExprU.pas',
  WildMatchU in 'miscU\WildMatchU.pas',
  alisp3WildU in 'alisp3\alisp3WildU.pas',
  //alisp3XREU in 'alisp3\alisp3XREU',
  alisp3RegU in 'alisp3\alisp3RegU.pas',
  alisp3DosU in 'alisp3\alisp3DosU.pas',
  lispCon3U in 'lispcon3\lispCon3U.pas',

  uralU in 'miscU\ural2\uralU.pas',

  fmoderrors in 'syslow\fmod\fmoderrors.pas',
  fmodtypes in 'syslow\fmod\fmodtypes.pas',
  dspFModU in 'sound\dspFModU.pas',

  dspVScrU in 'video\dspVScrU.pas',
  dspZXDrawU in 'machines\dspZXDrawU.pas',
  dspDDrawU in 'video\ddraw\dspDDrawU.pas',

  dspEmuMouseU in 'dspEmuMouseU.pas',
  dspDialogsU in 'dspDialogsU.pas',
  dspEmuVarsU in 'dspEmuVarsU.pas',
  dspEmuMiscU in 'dspEmuMiscU.pas',
  dspBetaU in 'disk\dspBetaU.pas',
  dzsLibU in 'dzslib\dzsLibU.pas',
  dspTZXU in 'tapes\dspTZXU.pas',
  dspLdrzU in 'tapes\dspLdrzU.pas',
  dspAYEngineU in 'sound\dspAYEngineU.pas',
  dspEmuSoundU in 'dspEmuSoundU.pas',
  dspFMU in 'sound\dspFMU.pas',
  dspMachConstU in 'machines\dspMachConstU.pas',
  dspPortGeneralU in 'machines\dspPortGeneralU.pas',
  dsp48kU in 'machines\dsp48kU.pas',
  dsp128kU in 'machines\dsp128kU.pas',
  dsp48k128kU in 'machines\dsp48k128kU.pas',
  dspMachineU in 'machines\dspMachineU.pas',

  zxFloatU in 'debugger\zxFloatU.pas',
  dspLabelsU in 'debugger\dspLabelsU.pas',
  dspUnasmU in 'debugger\dspUnasmU.pas',
  dspDbgU in 'debugger\dspDbgU.pas',

  dspWinU in 'winsys\dspWinU.pas',
  dspWLispApiU in 'winsys\dspWLispApiU.pas',

  dspEmuU in 'dspEmuU.pas',
  dspEmuBindU in 'dspEmuBindU.pas',
  dspEmuMenuU in 'dspEmuMenuU.pas',
  dspEmuMsgU in 'dspEmuMsgU.pas',
  dspLispApiU in 'dspLispApiU.pas';

{$R dsp.res}
{.$R logo.res}

{$INCLUDE btime.inc}

const
  dummyED06TrapStr =
    '(defun ed06-trap (addr) (begin (println "#ED/#06 trap at " addr) (con-execute "debugger tan;activate_debugger"))) '+
    '(defun ed06-trap-done (addr) *f*)';
  {dummySLTTrapStr =
    '(defun slt-trap (load-addr level pc-addr) (begin'+
    '  (println "SLT: load at " load-addr "; level " (chr level))'+
    '  (con-execute "activate_debugger") *f*'+
    ')) '+
    '(defun slt-trap-done (load-addr level pc-addr) *f*)';}
  dummySnapUnloadStr = '(defun snap-unload() *f* )';
  TZX_SIGN = 'ZXTape!'#26;
  TZX_DESCR: string = 'created by DarkSpecter!';


var
  dzsCompression: Byte = dzsPackW;
  doED06Traps: Boolean = true;
  lastSnapState: PDZSZ80State = nil;
  lastSnapLisp: string = '';
  tapeOutFile: string = 'tapeout.ztzx';
  showMainLogo: Boolean = true;
  kOnOffMsg: UINT;
  logoWH: HWND = 0; //     
  logoBmp: HBITMAP = 0;
  logoTimer: Integer = 0;


{$INCLUDE speccybmr.inc}
function CreateLogoBmp (): HBITMAP;
var
  dc, bdc: HDC;
  buf: packed array of Byte;
  wpal: packed array [0..255] of TColorRef;
  x, y, w, h, sz, f: Integer;
  obmp: HBITMAP;
begin
  w := PWord(@(speccyBMR[0]))^; h:= PWord(@(speccyBMR[2]))^;
  sz := w*h+768;
  SetLength(buf, sz);
  WDXUnpack(PByte(@(speccyBMR[4]))^, Length(speccyBMR)-4, buf[0], sz);
  for f := 0 to 255 do
  begin
    wpal[f] := buf[f*3+0] or (buf[f*3+1] shl 8) or (buf[f*3+2] shl 16);
  end;
  dc := GetDC(0); bdc := CreateCompatibleDC(dc);
  result := CreateCompatibleBitmap(dc, w, h);
  ReleaseDC(0, dc);
  obmp := SelectObject(bdc, result);
  f := 768;
  for y := 0 to h-1 do
  begin
    for x := 0 to w-1 do
    begin
      SetPixel(bdc, x, y, wpal[buf[f]]); Inc(f);
    end;
  end;
  SelectObject(bdc, obmp);
  DeleteDC(bdc);
end;


function LogoWndProc (wh: Integer; msg: LongWord; wParam, lParam: Integer): Integer; stdcall;
var
  dc, bdc: HDC;
  obmp: HBITMAP;
begin
  if msg = WM_ERASEBKGND then begin result := 1; exit; end;
  if msg = WM_DESTROY then
  begin
    KillTimer(wh, logoTimer); logoTimer := 0;
    logoWH := 0; __logoWH := 0;
  end;
  result := DefWindowProc(wh, msg, wParam, lParam);
  if msg = WM_PAINT then
  begin
    dc := GetDC(wh); bdc := CreateCompatibleDC(dc);
    obmp := SelectObject(bdc, logoBmp);
    BitBlt(dc, 0, 0, PWord(@(speccyBMR[0]))^, PWord(@(speccyBMR[2]))^,
      bdc, 0, 0, SRCCOPY);
    SelectObject(bdc, obmp);
    DeleteDC(bdc);
    ReleaseDC(wh, dc);
  end;
  if (msg = WM_KEYDOWN) or (msg = WM_SYSKEYDOWN) or
     (msg = WM_LBUTTONDOWN) or (msg = WM_RBUTTONDOWN) or (msg = WM_MBUTTONDOWN) or
     (msg = WM_TIMER) then PostMessage(wh, WM_CLOSE, 0, 0);
end;


procedure CreateMainLogoWindow ();
var
  wa: TRect;
  w, h: Integer;
begin
  if logoWH <> 0 then exit;
  if logoBmp = 0 then logoBmp := CreateLogoBmp();
  w := PWord(@(speccyBMR[0]))^; h:= PWord(@(speccyBMR[2]))^;
  if not SystemParametersInfo(SPI_GETWORKAREA, 0, @wa, 0) then
  begin
    wa.Left := 0; wa.Top := 0;
  end
  else
  begin
    wa.Left := wa.Left+(wa.Right-wa.Left-w) div 2;
    wa.Top := wa.Top+(wa.Bottom-wa.Top-h) div 2;
  end;
  logoWH := Windows.CreateWindowEx(
    WS_EX_TOOLWINDOW or WS_EX_TOPMOST, '#32770', 'Real Speccy %-)',
    WS_POPUP,
    wa.Left, wa.Top, w, h,
    0, 0, hInstance, nil);
  if logoWH = 0 then exit;
  __logoWH := logoWH;
  SetWindowLong(logoWH, GWL_WNDPROC, Integer(@LogoWndProc));
  ShowWindow(logoWH, SW_SHOWNOACTIVATE);
  //RedrawWindow(logoWH, nil, 0, RDW_INVALIDATE or RDW_NOERASE);
  InvalidateRect(logoWH, nil, false);
  UpdateWindow(logoWH);

  logoTimer := SetTimer(logoWH, 1, 5000, nil);
end;


function IsTZX (st: TStream): Boolean;
var
  sign: packed array [0..7] of Char;
  b: Byte;
  s: string;
begin
  st.Position := 0;
  s := LowerCase(ExtractFileExt(StringReplace(tapeOutFile, '/', '\', [rfReplaceAll])));
  if st.Size = 0 then
  begin
    //  
    result := (s = '.tzx') or (s = '.ztzx');
    if result then
    begin
      //  
      sign := TZX_SIGN; st.WriteBuffer(sign[0], 8); // 
      //  (1.10)
      b := 1; st.WriteBuffer(b, 1);
      b := 10; st.WriteBuffer(b, 1);
      // 
      b := $30; st.WriteBuffer(b, 1); //   
      b := Length(TZX_DESCR); st.WriteBuffer(b, 1);
      st.WriteBuffer(TZX_DESCR[1], Length(TZX_DESCR));
    end;
  end
  else
  begin
    if st.Size < 10 then result := false
    else
    begin
      result := (s = '.tzx') or (s = '.ztzx');
      (*//  
      st.ReadBuffer(sign[0], 8);
      result := (sign = TZX_SIGN);*)
    end;
    st.Position := st.Size; //     %-)
  end;
end;

function TapeSaveTrap (z80: PZ80CPU): Boolean;
var
  st: TFileStream;
  tzx: Boolean;
  b, parity: Byte;
  w: Word;
  buf: packed array of Byte;
  f, sz: Integer;
  packS: TWDXStream;
  saveS: TStream;
  ss: string;
begin
  result := false; buf := nil; packS := nil; st := nil;

  // check we're in the right ROM
  if emuPaging[0] <> 9 then exit;
  if tapeOutFile = '' then exit;

  try
    st := TFileStream.Create(tapeOutFile, fmOpenReadWrite or fmShareDenyWrite);
    if WDXIsBlockStream(st) then
    begin
      packS := TWDXUnpackStream.Create(st, false);
      saveS := packS;
    end
    else saveS := st;
  except
    //   ,  
    try
      st := TFileStream.Create(tapeOutFile, fmCreate);
      ss := LowerCase(ExtractFileExt(StringReplace(tapeOutFile, '/', '\', [rfReplaceAll])));
      if (ss = '.ztzx') or (ss = '.tpz') then
      begin
        packS := TWDXPackStream.Create(st);
        saveS := packS;
      end
      else saveS := st;
    except packS.Free(); st.Free(); exit; //  ...
    end;
  end;

  try
    WriteLn('saving ', z80.regDE, ' bytes from #', IntToHex(z80.regIX, 4), ' (', z80.regIX, ')');
    sz := z80.regDE; if sz = 0 then sz := 65536;
    parity := z80.regA;
    //  ,  parity
    SetLength(buf, sz);
    for f := 0 to sz-1 do
    begin
      buf[f] := Z80PeekBInternal(z80, (z80.regIX+f) and $FFFF);
      parity := parity xor buf[f];
    end;

    tzx := IsTZX(saveS);
    if tzx then
    begin
      //   
      if sz+2 > 65535 then
      begin
        //   ,  
        b := $11; saveS.WriteBuffer(b, 1); // 
        //   
        w := 2168; saveS.WriteBuffer(w, 2); //  
        w := 667; saveS.WriteBuffer(w, 2); //  
        w := 735; saveS.WriteBuffer(w, 2); //  
        w := 855; saveS.WriteBuffer(w, 2); // 
        w := 1710; saveS.WriteBuffer(w, 2); // 
        //  
        if z80.regA = 0 then w := 8064 else w := 3220;
        saveS.WriteBuffer(w, 2);
        b := 8; saveS.WriteBuffer(b, 1); //   
        w := 1000; saveS.WriteBuffer(w, 2); //   
        Inc(sz, 2); saveS.WriteBuffer(sz, 3); Dec(sz, 2); //  
      end
      else
      begin
        //  
        b := $10; saveS.WriteBuffer(b, 1); // 
        w := 1000; saveS.WriteBuffer(w, 2); //   
        Inc(sz, 2); saveS.WriteBuffer(sz, 2); Dec(sz, 2); //  
      end;
    end
    else
    begin
      if sz+2 > 65535 then exit; //    ! TZX !
      Inc(sz, 2); saveS.WriteBuffer(sz, 2); Dec(sz, 2); //  
    end;
    //  
    b := z80.regA; saveS.WriteBuffer(b, 1);
    //  
    if sz > 0 then saveS.WriteBuffer(buf[0], sz);
    //  parity
    saveS.WriteBuffer(parity, 1);
    packS.Free();
    st.Free();
    //   
    Inc(z80.regIX, z80.regDE); z80.regDE := 0;
    // return via the RET at #053E
    z80.regPC := $053E;
    result := true;
  except on e: Exception do
    begin
      WriteLn('***TAPE SAVE ERROR: [', e.ClassName, '] ', e.Message);
      packS.Free(); st.Free(); exit;
    end;
  end;
end;

procedure CmdTapeOutFile (const cmd: string; const args: array of string);
var
  fName: string;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('set tape output file.');
    WriteLn('usage: tape-out-file [filename]');
    exit;
  end;

  fName := ConGetArgStr(1, args);
  if fName <> '' then tapeOutFile := fName;
  WriteLn('tape output file: "', tapeOutFile, '"');
end;

procedure ALispEvalStr (const s: string);
begin
  //ALEvalStr('(clear-context-stack)');
  ALEvalStr(s);
end;

{$I-}
procedure CmdLoadScript (const cmd: string; const args: array of string);
var
  fi: Text;
  s: string;
  fName: string;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('execute script.');
    WriteLn('usage: exec filename');
    exit;
  end;

  fName := ConGetArgStr(1, args);
  if not FileExists(fName) then fName := FileSearchEx(fName, '.;$(appdir)');
  if fName = '' then
  begin
    WriteLn('exec what?');
    exit;
  end;

  if IsSpecialFile(fName) then
  begin
    WriteLn('too smart, eh?');
    exit;
  end;

  AssignFile(fi, fName);
  Reset(fi);
  if IOResult <> 0 then
  begin
    WriteLn('exec "', fName, '"?');
    exit;
  end;

  try
    try
      while not EOF(fi) do
      begin
        ReadLn(fi, s); if IOResult <> 0 then exit;
        ConExecute(s);
      end;
      WriteLn('"', fName, '" executed ok');
    finally
      CloseFile(fi);
    end;
  except
    // shitty code! %-)
    WriteLn('"', fName, '" failed to execute completely');
  end;
end;
{$I+}

procedure CmdQuit (const cmd: string; const args: array of string);
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('quit DSP.');
    WriteLn('usage: quit [force]');
    WriteLn('forced quit shutdowns DSP immediately');
    exit;
  end;

  if ConGetArgStr(1, args) = 'force' then Halt(666);
  PostQuitMessage(0);
end;


procedure CmdShowCPUSpeed (const cmd: string; const args: array of string);
{$IFNDEF USE_HP_TIMER}
var
  cpuSpeed: TFreqInfo;
{$ENDIF}
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('show CPU speed (not Z80!).');
    WriteLn('usage: cpuspeed');
    exit;
  end;

  {$IFDEF USE_HP_TIMER}
  if CPU86GetDetectedSpeed() <> 0 then
  {$ELSE}
  if GetCPUSpeed(cpuSpeed) then
  {$ENDIF}
  begin
    {$IFDEF USE_HP_TIMER}
    WriteLn('processor speed: ', CPU86GetDetectedSpeed(), ' MHz');
    {$ELSE}
    WriteLn('processor speed: ', cpuSpeed.RawFreq, ' MHz');
    {$ENDIF}
    WriteLn;
  end;
end;

function StrN (n, wdt: Integer): string;
begin
  Str(n:wdt, result);
end;


procedure PokeB (addr: Word; val: Byte);
begin
  Z80PokeBInternal(emuZ80, addr, val);
end;

procedure PokeW (addr, val: Word);
begin
  Z80PokeBInternal(emuZ80, addr, val and $FF);
  Z80PokeBInternal(emuZ80, addr+1, (val shr 8) and $FF);
end;

function PeekB (addr: Word): Byte;
begin
  result := Z80PeekBInternal(emuZ80, addr);
end;

function PeekW (addr: Word): Word;
begin
  result := Z80PeekBInternal(emuZ80, addr) or
    (Z80PeekBInternal(emuZ80, addr+1) shl 8);
end;

var
  inTrDosSelector: Boolean = false;

procedure CmdTrDosExtract (const cmd: string; const args: array of string);
type
  PByte = ^Byte;
  PWord = ^Word;
const
  basAddr = $5B00;

  clr: TMenuColors = (
    // normal
    //  norm   mover
   (((7, 0), (15, 2)),  // normal
    ((0, 6), ( 0,14))), // cursor
    // marked
    //  norm   mover
   (((15, 1), (15, 3)),  // normal
    (( 0,15), ( 9,15))));// cursor
  menuClr: TMenuColors = (
    // normal
    //  norm   mover
   (((0,14), ( 0,6)),  // normal
    ((7, 1), (15,9))), // cursor
    // marked
    //  norm   mover
   (((7,14), (7,14)),  // normal
    ((7,14), (7,14))));// cursor
var
  msg: TMsg;
  mouseWasHidden: Boolean;
  disk: TDiskImage;
  trFiles: array of string;
  trSelected: array of Boolean;
  cur, f: Integer;
  ch: Char;
  s: string;
  stF, selC: Integer;
  y, menuI, mouseI: Integer;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('extract trFiles from disk image.');
    WriteLn('usage: trdos_extract [drive]');
    exit;
  end;

  if inTrDosSelector then exit;

  inTrDosSelector := true;
  ConExecute('console ona');
  ConExecute('temp_pause tan');
  mouseWasHidden := emuMouseHidden; EmuHideMouse();
  trFiles := nil; trSelected := nil;

  f := ConGetArgDisk(1, args); if (f < 0) or (f > 3) then f := 0;
  WriteLn('exploring disk in drive ', chr(ord('A')+f), ':');

  disk := emuDisks.disks[f];
  try
    if not disk.IsTRDisk then
    begin
      WriteLn('not a TR-DOS disk');
      WriteLn(
        '#', IntToHex(PByte(Integer(disk.LogSectorData(8))+$E7)^, 2),
        '; #', IntToHex(PByte(Integer(disk.LogSectorData(8))+$E3)^, 2))
      //(fDisk^[$08E3] = $17)) and  // 80T,SS
      //(fDisk^[$08E7] = $10);     // trdos flag
      //exit;
    end;

    cur := disk.TRFileCount();
    if cur = 0 then
    begin
      WriteLn('empty TR-DOS disk!');
      //exit;
    end;

    SetLength(trFiles, cur);
    SetLength(trSelected, cur+1);
    selC := 0;
    for f := 0 to cur-1 do
    begin
      trFiles[f] := ' '+disk.TRFileName(f)+'.'+disk.TRFileExt(f)+' ';
      trSelected[f] := false;
    end;

    cur := 0; stF := 0;
    repeat
      EmuRenderScreenNoInv();

      y := Length(trFiles);
      if y > 64 then y := 16
      else
      begin
        y := ((y-1) div 4)+1;
      end;
      mouseI := MenuXY(
        0, 90,          // x, y
        48, y,          // w, h (chars)
        1, 1,           // hborder, vborder
        trFiles, trSelected,// items, marked
        cur, stF,       // cursor, topitem
        4, 12,          // rows, row width
        0, 12, 0, clr,     // colors
        emuMouseX, emuMouseY);

      menuI := MenuXY(
        //0, 60,   // x, y
        290, 90, // x, y
        4, 5,           // w, h (chars)
        1, 1,           // hborder, vborder
        ['SAVE', 'EXIT', '', 'PGUP', 'PGDN'], // items
        [disk.TRFileCount() = 0, false, false, stF=0, stF+64>Length(trFiles)], // marked
        -1, 0,          // cursor, topitem
        1, 6,           // rows, row width
        15, 0, 14, menuClr, // colors
        emuMouseX, emuMouseY);

      VFillRect(0, 68, 320, 22, 255, 0);
      VFillRect(1, 69, 318, 20, 0, 7);
      if mouseI <> -1 then
      begin
        if disk.TRFileExt(mouseI) = 'B' then
        begin
          f := Integer(disk.TRFileData(mouseI))+disk.TRFileStart(mouseI);
          if PWord(f)^ = $AA80 then f := PWord(f+2)^ else f := 0;
          s := trFiles[mouseI]+'  prgl:#'+IntToHex(disk.TRFileSize(mouseI), 4)+
            ' full:#'+IntToHex(disk.TRFileStart(mouseI), 4)+
            '  sect:'+StrN(disk.TRFileSecSize(mouseI), 3)+' ('+StrN(f, 4)+')';
          DrawText(3, 71, s, 7, 0);
          s := trFiles[mouseI]+'  prgl:'+StrN(disk.TRFileSize(mouseI), 5)+
            ' full:'+StrN(disk.TRFileStart(mouseI), 5)+
            '  sect:'+StrN(disk.TRFileSecSize(mouseI), 3)+' ('+StrN(f, 4)+')';
          DrawText(3, 79, s, 7, 0);
        end
        else
        begin
          s := trFiles[mouseI]+'  start:#'+IntToHex(disk.TRFileStart(mouseI), 4)+
            ' len:#'+IntToHex(disk.TRFileSize(mouseI), 4)+
            '  sect:'+StrN(disk.TRFileSecSize(mouseI), 3);
          DrawText(3, 71, s, 7, 0);
          s := trFiles[mouseI]+'  start:'+StrN(disk.TRFileStart(mouseI), 5)+
            ' len:'+StrN(disk.TRFileSize(mouseI), 5)+
            '  sect:'+StrN(disk.TRFileSecSize(mouseI), 3);
          DrawText(3, 79, s, 7, 0);
        end;
      end;

      // what file is under the mouse cursor?
      EmuDrawCursor();
      EmuDrawScreen();

      ch := #0;
      if EmuReadKeyMouse(msg) then
      begin
        if not emuMouseHidden then EmuHideMouse();

        if msg.message = WM_RBUTTONDOWN then
        begin
          if mouseI <> -1 then
          begin
            f := Integer(disk.TRFileData(mouseI));
            y := disk.TRFileSize(mouseI); if y > 6912 then y := 6912;
            if y > 0 then Move(Pointer(f)^, emuMemory[emuScreenPage], y);
          end
        end
        else if msg.message = WM_LBUTTONDBLCLK then
        begin
          // trdos: run basic
          if (mouseI <> -1) and (disk.TRFileExt(mouseI) = 'B') then
          begin
          end;
        end
        else if msg.message = WM_LBUTTONDOWN then
        begin
          if mouseI <> -1 then cur := mouseI;
          if msg.message = WM_LBUTTONDBLCLK then
          begin
            if mouseI <> -1 then ch := #13;
          end
          else if mouseI <> -1 then
          begin
            trSelected[cur] := not trSelected[cur];
            if trSelected[cur] then Inc(selC) else Dec(selC);
          end
          else if menuI = 0 then ch := #13
          else if menuI = 1 then ch := #27
          else if menuI = 3 then Dec(cur, 64)
          else if menuI = 4 then
          begin
            if cur < 64 then Inc(cur, 64);
            stF := 64;
          end;
          EmuProcessWinMessage(msg);
        end
        else if msg.message = WM_CHAR then
        begin
          ch := chr(msg.wParam and $FF);
          case ch of
            ' ':
              begin
                trSelected[cur] := not trSelected[cur];
                if trSelected[cur] then Inc(selC) else Dec(selC);
              end;
            ^A:
              begin
                selC := Length(trFiles);
                for f := 0 to High(trSelected) do trSelected[f] := true;
              end;
            ^U:
              begin
                selC := 0;
                for f := 0 to High(trSelected) do trSelected[f] := false;
              end;
          end;
          if ch = #1 then ch := #0;
        end
        else if msg.message = WM_KEYDOWN then
        begin
          case msg.wParam and $FFFF of
            VK_HOME: cur := 0;
            VK_UP: Dec(cur, 4);
            VK_LEFT: Dec(cur);
            VK_RIGHT: Inc(cur);
            VK_DOWN: Inc(cur, 4);
            VK_END: cur := High(trFiles);
            else EmuProcessWinMessage(msg);
          end;
        end
        else EmuProcessWinMessage(msg);

        if cur < 0 then cur := 0 else if cur > High(trFiles) then cur := High(trFiles);
        while cur < stF do Dec(stF, 3);
        while stF> cur+64 do Inc(stF, 3);
        if stF > High(trFiles) then stF := (High(trFiles) div 3)*3;
        if stF < 0 then stF := 0;
      end;
    until emuQuit or ((ch = #13) and (Length(trFiles) > 0)) or (ch = #27) or (ch = #1);

    if selC = 0 then trSelected[cur] := true;

    if not emuQuit and (ch = #13) then
    begin
      for cur := 0 to High(trFiles) do
      begin
        if not trSelected[cur] then continue;
        s := Copy(trFiles[cur], 2, 10); Insert('$', s, 10);
        for f := 1 to Length(s) do
        begin
          if s[f] in [#0..' ','*','|','/','\',':','<','>','?',#127..#255] then s[f] := '_';
          if s[f] = '"' then s[f] := #39;
        end;

        if FileExists(s) then
        begin
          Write('file "'+s+'" already exists. renamed to "');
          f := 0;
          while FileExists('('+IntToHex(f, 2)+')'+s) do Inc(f);
          s := '('+IntToHex(f, 2)+')'+s;
          WriteLn(s, '"');
        end;

        try
          disk.TRFileSaveHob(cur, s);
          WriteLn('"', s, '" written');
        except on e: Exception do
          WriteLn('*', e.ClassName, ': ', e.Message);
        end;
      end;
    end;

    WaitKeybRelease();
  finally
    inTrDosSelector := false;
    ConExecute('temp_pause ona');
    if not mouseWasHidden then EmuShowMouse();
  end;
end;


procedure CmdPoke (const cmd: string; const args: array of string);
var
  c, page, addr, value: Integer;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('POKE data.');
    WriteLn('usage: poke [page] address value');
    exit;
  end;

  if ConGetArgCount(args) < 2 then
  begin
    WriteLn('wtf?');
    exit;
  end;

  if ConGetArgCount(args) > 2 then begin page := ConGetArgIntDef(1, args, -2); c := 2; end
  else begin page := -1; c := 1; end;
  addr := ConGetArgIntDef(c, args, -1);
  value := ConGetArgIntDef(c+1, args, -1);
  if (page < -1) or (page > 7) or (addr < 0) or (addr > 65535) or (value < 0) or (value > 255) then
  begin
    WriteLn('wts?');
    exit;
  end;

  if addr < 16384 then
  begin
    WriteLn('ROM poking? it''s funny.');
    exit;
  end;

  if page = -1 then page := emuPaging[(addr and $C000) shr 14]
  else
  begin
    if addr < $C000 then begin WriteLn('???'); exit; end;
    page := emuPaging[3];
  end;

  WriteLn('old value: ', emuMemory[page, (addr and $3FFF)],
    ' (#', IntToHex(emuMemory[page, (addr and $3FFF)], 2), ')');
  emuMemory[page, (addr and $3FFF)] := value;
end;

procedure CmdPeek (const cmd: string; const args: array of string);
var
  c, page, addr: Integer;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('PEEK data.');
    WriteLn('usage: peek [page] address');
    exit;
  end;

  if ConGetArgCount(args) < 1 then
  begin
    WriteLn('wtf?');
    exit;
  end;

  if ConGetArgCount(args) > 1 then begin page := ConGetArgIntDef(1, args, -2); c := 2; end
  else begin page := -1; c := 1; end;
  addr := ConGetArgIntDef(c, args, -1);
  if (page < -1) or (page > 7) or (addr < 0) or (addr > 65535) then
  begin
    WriteLn('wts?');
    exit;
  end;

  if page = -1 then page := emuPaging[(addr and $C000) shr 14]
  else
  begin
    if addr < $C000 then begin WriteLn('???'); exit; end;
    page := emuPaging[3];
  end;

  WriteLn('value: ', emuMemory[page, (addr and $3FFF)],
    ' (#', IntToHex(emuMemory[page, (addr and $3FFF)], 2), ')');
end;

procedure CmdOut (const cmd: string; const args: array of string);
var
  addr, value: Integer;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('OUT data.');
    WriteLn('usage: out port value');
    exit;
  end;

  if ConGetArgCount(args) < 2 then
  begin
    WriteLn('wtf?');
    exit;
  end;

  addr := ConGetArgIntDef(1, args, -1);
  value := ConGetArgIntDef(2, args, -1);
  if (addr < 0) or (addr > 65535) or (value < 0) or (value > 255) then
  begin
    WriteLn('wts?');
    exit;
  end;

  Z80PortOut(emuZ80, addr, value);
  WriteLn('out #', IntToHex(addr, 4), ',#', IntToHex(value, 2));
end;

procedure CmdIn (const cmd: string; const args: array of string);
var
  addr: Integer;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('IN data.');
    WriteLn('usage: in address');
    exit;
  end;

  if ConGetArgCount(args) < 1 then
  begin
    WriteLn('wtf?');
    exit;
  end;

  addr := ConGetArgIntDef(1, args, -1);
  if (addr < 0) or (addr > 65535) then
  begin
    WriteLn('wts?');
    exit;
  end;

  WriteLn('in #', IntToHex(addr, 4), ',#', IntToHex(Z80PortIn(emuZ80, addr), 2));
end;


var
  lastFindEnd: Integer = 65536;
  lastFindVal: Integer = 0;
  lastFindByte: Boolean = true;

procedure CmdFind (const cmd: string; const args: array of string);
var
  cnt, addr, value: Integer;
  byt: Boolean;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('searches for data.');
    WriteLn('usage: '+cmd+' [value [startaddress]]');
    exit;
  end;

  if ConGetArgCount(args) < 1 then
  begin
    addr := lastFindEnd;
    if addr > 65535 then addr := 16384+6912;
    byt := lastFindByte;
    value := lastFindVal;
    Write('continue searching ');
    if byt then Write('byte ') else Write('word ');
    WriteLn(value, ' from ', addr);
  end
  else
  begin
    byt := (cmd = 'findb');
    value := ConGetArgIntDef(1, args, -2);
    if ConGetArgCount(args) > 1 then addr := ConGetArgIntDef(2, args, -2)
    else addr := 16384+6912;
    if (addr < 0) or (addr > 65535) or (value < 0) or (value > 65535) then
    begin
      WriteLn('wts?');
      exit;
    end;
    if byt and (value > 255) then
    begin
      WriteLn('wts?');
      exit;
    end;
    Write('searching ');
    if byt then Write('byte ') else Write('word ');
    WriteLn(value, ' from ', addr);
    lastFindVal := value; lastFindByte := byt;
  end;

  cnt := 0;
  repeat
    if byt then
    begin
      while (addr <= 65535) and (PeekB(addr) <> value) do Inc(addr);
    end
    else
    begin
      while (addr <= 65535) and (PeekW(addr) <> value) do Inc(addr);
    end;

    if addr < 65536 then
    begin
      WriteLn('found at #', IntToHex(addr, 4), ' (', addr, ')');
      Inc(addr);
      Inc(cnt);
      if cnt = 8 then break;
    end;
  until addr > 65535;
  if addr > 65535 then WriteLn('done.');
  lastFindEnd := addr;
end;

procedure CmdDump (const cmd: string; const args: array of string);
var
  f, c, addr, value: Integer;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('dumps memory.');
    WriteLn('usage: dump startaddress');
    exit;
  end;

  if ConGetArgCount(args) < 1 then
  begin
    WriteLn('wtf?');
    exit;
  end;

  addr := ConGetArgIntDef(1, args, -2);
  if (addr < 0) or (addr > 65535) then
  begin
    WriteLn('wts?');
    exit;
  end;

  for f := 0 to 7 do
  begin
    Write(IntToHex(addr, 4), ': ');
    for c := 0 to 7 do Write(IntToHex(PeekB(addr+c), 2), ' ');
    Write(' ');
    for c := 0 to 7 do
    begin
      value := PeekB(addr+c);
      if (value and $FF) in [0, 8..13, 255] then value := 46;
      Write(chr(value));
    end;
    Inc(addr, 8);
    WriteLn;
  end;
end;


var
  memdup: packed array [0..34, 0..16383] of Byte;

procedure CmdDup (const cmd: string; const args: array of string);
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('saves current memory state.');
    WriteLn('usage: dup');
    exit;
  end;
  Move(emuMemory, memdup, SizeOf(memDup));
  WriteLn('memory saved');
end;

function XPeekB (addr: Word): Byte;
begin
  result := memdup[emuPaging[(addr and $C000) shr 14], (addr and $3FFF)];
end;

procedure CmdXPeek (const cmd: string; const args: array of string);
var
  c, page, addr: Integer;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('PEEK "duped" data.');
    WriteLn('usage: xpeek [page] address');
    exit;
  end;

  if ConGetArgCount(args) < 1 then
  begin
    WriteLn('wtf?');
    exit;
  end;

  if ConGetArgCount(args) > 1 then begin page := ConGetArgIntDef(1, args, -2); c := 2; end
  else begin page := -1; c := 1; end;
  addr := ConGetArgIntDef(c, args, -1);
  if (page < -1) or (page > 7) or (addr < 0) or (addr > 65535) then
  begin
    WriteLn('wts?');
    exit;
  end;

  if page = -1 then page := emuPaging[(addr and $C000) shr 14]
  else
  begin
    if addr < $C000 then begin WriteLn('???'); exit; end;
    page := emuPaging[3];
  end;

  WriteLn('value: ', memdup[page, (addr and $3FFF)],
    ' (#', IntToHex(memdup[page, (addr and $3FFF)], 2), ')');
end;

procedure CmdDiff (const cmd: string; const args: array of string);
var
  f, cnt, addr, dif, dv, mv: Integer;
  s: string;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('"diffs" saved memory and current one.');
    WriteLn('usage: '+cmd+' [opts]');
    WriteLn('  opts:');
    WriteLn('    d diffvalue [default: 1]');
    WriteLn('    nd neg_diffvalue');
    WriteLn('    a startaddress');
    WriteLn('    dv dumpvalue');
    WriteLn('    mv memvalue');
    exit;
  end;

  addr := 16384+6912; dif := 1; dv := -1; mv := -1;
  f := 1;
  while f < ConGetArgCount(args) do
  begin
    cnt := ConGetArgIntDef(f+1, args, -100000);
    if cnt < 0 then begin WriteLn('value?'); exit; end;
    s := ConGetArgStr(f, args);
    if s = 'd' then dif := cnt
    //else if s = 'nd' then dif := -cnt
    else if s = 'a' then addr := cnt
    else if s = 'dv' then dv := cnt
    else if s = 'mv' then mv := cnt
    else begin WriteLn('option?'); exit; end;
    Inc(f, 2);
  end;
  if (addr < 0) or (addr > 65535) or (dv > 255) or (mv > 255) or (dif > 255) or (dif < -255) then
  begin
    WriteLn('values?');
    exit;
  end;

  WriteLn('a: ', addr, '; d: ', dif, '; dv: ', dv, '; mv: ', mv);
  cnt := 0;
  while addr < 65536 do
  begin
    if ((dif = 0) or (abs(Integer(XPeekB(addr))-Integer(PeekB(addr))) = dif)) and
       ((dv = -1) or (XPeekB(addr) = dv)) and
       ((mv = -1) or (PeekB(addr) = mv)) then
    begin
      Write('found at #', IntToHex(addr, 4), ' (', addr, ')');
      Write(' d:#', IntToHex(XPeekB(addr), 2), '; m:#', IntToHex(PeekB(addr), 2));
      WriteLn('; d:', XPeekB(addr):3, '; m:', PeekB(addr):3);

      {WriteLn('found at #', IntToHex(addr, 4), ' (', addr, ')');
      Write('  d: #', IntToHex(XPeekB(addr), 2), '; m: #', IntToHex(PeekB(addr), 2));
      WriteLn('  d: ', XPeekB(addr):3, '; m: ', PeekB(addr):3);}
      Inc(cnt);
      if cnt = 6 then break;
    end;
    Inc(addr);
  end;
  if addr > 65535 then WriteLn('done.');
end;


procedure ClearStdLsp ();
begin
  //if not ALIsNil(ALFindSymbol('on-loaded')) then ALispEvalStr('(undefine ''on-loaded)');
  //if not ALIsNil(ALFindSymbol('snap-unload')) then ALispEvalStr('(undefine ''snap-unload)');
  //if not ALIsNil(ALFindSymbol('ed06-trap')) then ALispEvalStr('(undefine ''ed06-trap)');
  //if not ALIsNil(ALFindSymbol('ed06-trap-done')) then ALispEvalStr('(undefine ''ed06-trap-done)');
  ALispEvalStr(dummySnapUnloadStr);
  ALispEvalStr(dummyED06TrapStr);
end;

procedure DefineStdLsp ();
begin
  //if ALIsNil(ALFindSymbol('on-loaded')) then ALispEvalStr('(defun on-loaded () *f*)');
  {if ALIsNil(ALFindSymbol('snap-unload')) then ALispEvalStr('(defun snap-unload () *f*)');
  if ALIsNil(ALFindSymbol('ed06-trap')) then
    ALispEvalStr('(defun ed06-trap (addr) (begin (println "#ED/#06 trap at " addr) (con-execute "debugger tan;activate_debugger")))');
  if ALIsNil(ALFindSymbol('ed06-trap-done')) then ALispEvalStr('(defun ed06-trap-done (addr) *f*)');}
end;

function IsLispBlock (blk: PDZSMemBlock): Boolean;
var
  sgn: string[13];
begin
  result := false;
  if blk = nil then exit;
  if blk.page <> 13 then exit;
  if Length(blk.data) < 13 then exit;
  sgn[0] := #13; Move(blk.data[0], sgn[1], 13);
  result := (sgn = 'k8DSPemuLSP3'#0);
end;

procedure LoadSnap (fName: string; destDisk: Integer);
var
  fi: TFileStream;
  scr: packed array [0..6911] of Byte;
  tap: TZXTape;
  sign: packed array [0..3] of Char;
  //sgn2: string[8];
  ad, sz, pcnt, pc: Word;
  b: Byte;
  s, t: string;
  //f: Integer;
  blk: PDZSMemBlock;
  unpackS: TWDXUnpackStream;

  procedure LoadLsp ();
  begin
    if FileExists(t) then
    begin
      ALispEvalStr('(load '+ALEscapeStrEx(t, true, '"')+')');
    end;
    //DefineStdLsp();
    ALispEvalStr('(on-loaded)');
  end;

  procedure ShowLevels ();
  var
    blk: PDZSMemBlock;
    cnt: Integer;
  begin
    if lastSnapState = nil then exit;
    blk := lastSnapState.blocks;
    cnt := 0; while blk <> nil do
    begin
      WriteLn(cnt, ': level ', blk.page, '; ', Length(blk.data), ' bytes');
      Inc(cnt); blk := blk.next;
    end;
  end;

begin
  fName := StringReplace(fName, '/', '\', [rfReplaceAll]);
  WriteLn('loading snapshot "', fName, '"');
  DZSFreeStateRec(lastSnapState);
  lastSnapState := DZSNewStateRec();
  //try
  try
    EmuStopTape();

    lastSnapLisp := '';
    if (LowerCase(ExtractFileExt(fName)) <> '.scr') and
       (Copy(ExtractFileExt(fName), 1, 2) <> '.$') then
    begin
      // BUG: sort out RAW filez!
      //WriteLn('unloading snapshot...');
      ALispEvalStr('(snap-unload)');
      //ALispEvalStr(dummySnapUnloadStr);
      //ALispEvalStr(dummyED06TrapStr);
      ClearStdLsp();
      ALispEvalStr('(setq prev-snap-file latest-snap-file  latest-snap-file *nil*)');
      s := ExpandFileName(fName);
      t := s;
      ALispEvalStr('(setq latest-snap-file '+ALEscapeStrEx(s, true, '"')+')');
      t := ChangeFileExt(t, '.l');
      lastSnapLisp := t;
    end
    else t := '<>';

    if LowerCase(ExtractFileExt(fName)) = '.dzs' then
    begin
      DZSLoadFromFile(fName, lastSnapState, true);
      // find DZS lisp block
      if lastSnapState = nil then blk := nil else blk := lastSnapState.unkBlocks;
      s := '';
      while blk <> nil do
      begin
        if IsLispBlock(blk) then
        begin
          // ALISP3 sources
          SetLength(s, Length(blk.data)-13); UniqueString(s);
          if s <> '' then Move(blk.data[13], s[1], Length(s));
          s := Trim(s);
        end;
        blk := blk.next;
      end;
      //ClearStdLsp();
      if s <> '' then ALispEvalStr(s);
      LoadLsp();
      ShowLevels();
    end
    else if LowerCase(ExtractFileExt(fName)) = '.z80' then
    begin
      DZSLoadZ80(fName, lastSnapState);
      LoadLsp();
      ShowLevels();
    end
    else if LowerCase(ExtractFileExt(fName)) = '.slt' then
    begin
      DZSLoadZ80(fName, lastSnapState);
      LoadLsp();
      ShowLevels();
    end
    else if LowerCase(ExtractFileExt(fName)) = '.sna' then
    begin
      DZSLoadSNA(fName, lastSnapState);
      LoadLsp();
    end
    else if LowerCase(ExtractFileExt(fName)) = '.dmb' then
    begin
      // memory dump
      fi := TFileStream.Create(fName, fmOpenRead or fmShareDenyWrite);
      try
        fi.ReadBuffer(sign[0], 4);
        if sign <> 'DMB0' then begin WriteLn('ERROR: invalid DMB file!'); exit; end;
        fi.ReadBuffer(pc, 2); // unused for now
        fi.ReadBuffer(pcnt, 2);
        while pcnt <> 0 do
        begin
          fi.ReadBuffer(sz, 2);
          fi.ReadBuffer(ad, 2);
          WriteLn('addr=#', IntToHex(ad, 4), ' (', ad, '), size=#',
            IntToHex(sz, 4), ' (', sz, ')');
          //if sz = 0 then begin WriteLn('ERROR: invalid DMB size!'); exit; end;
          while sz <> 0 do
          begin
            fi.ReadBuffer(b, 1); Z80PokeBInternal(emuZ80, ad, b);
            Inc(ad); Dec(sz);
          end;
          Dec(pcnt);
        end;
        LoadLsp();
        exit;
      finally
        fi.Free();
      end;
    end
    else if LowerCase(ExtractFileExt(fName)) = '.scr' then
    begin
      fi := TFileStream.Create(fName, fmOpenRead or fmShareDenyWrite);
      try
        Fillchar(scr[0], 6912, 0);
        if fi.Size = 6912 then fi.ReadBuffer(scr[0], 6912)
        else if fi.Size = 6144 then
        begin
          fi.ReadBuffer(scr[0], 6144); FillChar(scr[6144], 768, 7);
        end;
        Move(scr[0], emuMemory[emuScreenPage], 6912);
        EmuRenderScreen(); EmuDrawScreen();
        ConExecute('pause tan');
        exit;
      finally
        fi.Free();
      end;
    end
    else if LowerCase(ExtractFileExt(fName)) = '.trd' then
    begin
      emuDisks.disks[destDisk].FileName := fName; // this loads
      LoadLsp();
      exit;
    end
    else if LowerCase(ExtractFileExt(fName)) = '.trz' then
    begin
      emuDisks.disks[destDisk].FileName := fName; // this loads
      LoadLsp();
      exit;
    end
    else if LowerCase(ExtractFileExt(fName)) = '.scl' then
    begin
      emuDisks.disks[destDisk].FileName := fName; // this loads
      LoadLsp();
      exit;
    end
    else if LowerCase(ExtractFileExt(fName)) = '.scz' then
    begin
      emuDisks.disks[destDisk].FileName := fName; // this loads
      LoadLsp();
      exit;
    end
    else if Copy(ExtractFileExt(fName), 1, 2) = '.$' then
    begin
      emuDisks.disks[destDisk].FileName := fName; // this loads
      exit;
    end
    else if (LowerCase(ExtractFileExt(fName)) = '.tap') or
            (LowerCase(ExtractFileExt(fName)) = '.tpz') then
    begin
      try
        emuTapeInfo.tape.Clear(); tap := nil; unpackS := nil;
        fi := TFileStream.Create(fName, fmOpenRead or fmShareDenyWrite);
        try
          if WDXIsBlockStream(fi) then
          begin
            unpackS := TWDXUnpackStream.Create(fi, false);
            tap := LoadLunterTapeFromStream(unpackS);
          end
          else tap := LoadLunterTapeFromStream(fi);
          WriteLn('lunter tape ok');
          EmuRewindTape();
          emuTapeInfo.tape.Build(tap);
          LoadLsp();
        finally
          tap.Free();
          unpackS.Free();
          fi.Free();
        end;
      except on e: Exception do
        begin
          ALispEvalStr('(setq latest-snap-file *nil*)');
          WriteLn('***TAPE LOADING ERROR: [', e.ClassName, '] ', e.Message);
          //emuTapeInfo.tape.Free(); emuTapeInfo.tape := nil;
          emuTapeInfo.tape.Clear();
        end;
      end;
      exit;
    end
    else if (LowerCase(ExtractFileExt(fName)) = '.tzx') or
            (LowerCase(ExtractFileExt(fName)) = '.ztzx') then
    begin
      try
        emuTapeInfo.tape.Clear(); tap := nil; unpackS := nil;
        fi := TFileStream.Create(fName, fmOpenRead or fmShareDenyWrite);
        try
          tap := TZXTape.Create();
          if WDXIsBlockStream(fi) then
          begin
            unpackS := TWDXUnpackStream.Create(fi, false);
            tap.LoadFromStream(unpackS);
          end
          else tap.LoadFromStream(fi);
          WriteLn('tzx tape ok');
          EmuRewindTape();
          emuTapeInfo.tape.Build(tap);
          LoadLsp();
        finally
          tap.Free();
          unpackS.Free(); fi.Free();
        end;
      except on e: Exception do
        begin
          ALispEvalStr('(setq latest-snap-file *nil*)');
          WriteLn('***TZX LOADING ERROR: [', e.ClassName, '] ', e.Message);
          //emuTapeInfo.tape.Free(); emuTapeInfo.tape := nil;
          emuTapeInfo.tape.Clear();
        end;
      end;
      exit;
    end
    else
    begin
      WriteLn('unknown file format, addind to disk as RAW file');
      emuDisks.disks[destDisk].FileName := fName; // this loads
      exit;
    end;
    EmuRealizeState(lastSnapState);
  {finally
    DefineStdLsp();
  end;}
  except on e: Exception do
    begin
      DZSFreeStateRec(lastSnapState);
      ALispEvalStr('(setq latest-snap-file *nil*)');
      WriteLn('***LOADING ERROR: [', e.ClassName, '] ', e.Message);
    end;
  end;
end;

procedure SaveSnap (fName: string; quick: Boolean);
var
  zstate: PDZSZ80State;
  blk, lblk, cb: PDZSMemBlock;
begin
  fName := StringReplace(fName, '/', '\', [rfReplaceAll]);
  if ExtractFileExt(fName) = '' then fName := fName+'.dzs';
  WriteLn('saving snapshot "', fName, '"');
  zstate := EmuGetState();
  try
    if quick and (lastSnapState <> nil) then
    begin
      // copy blocks
      lblk := nil; blk := lastSnapState.blocks;
      while blk <> nil do
      begin
        New(cb); cb.next := nil; cb.page := blk.page; cb.data := nil;
        try
          if Length(blk.data) > 0 then cb.data := Copy(blk.data);
          if lblk = nil then zstate.blocks := cb else lblk.next := cb;
          lblk := cb;
        except
          cb.data := nil; Dispose(cb);
          raise;
        end;
        blk := blk.next;
      end;

      lblk := nil; blk := lastSnapState.unkBlocks;
      while blk <> nil do
      begin
        New(cb); cb.next := nil; cb.page := blk.page; cb.data := nil;
        try
          if Length(blk.data) > 0 then cb.data := Copy(blk.data);
          if lblk = nil then zstate.unkBlocks := cb else lblk.next := cb;
          lblk := cb;
        except
          cb.data := nil; Dispose(cb);
          raise;
        end;
        blk := blk.next;
      end;
    end;
    try
      if LowerCase(ExtractFileExt(fName)) = '.z80' then
      begin
        if zstate.blocks <> nil then DZSSaveZ80(ChangeFileExt(fName, '.slt'), zstate, dzsCompression)
        else DZSSaveZ80(fName, zstate, dzsCompression);
      end
      else if LowerCase(ExtractFileExt(fName)) = '.slt' then
      begin
        if zstate.blocks = nil then DZSSaveZ80(ChangeFileExt(fName, '.z80'), zstate, dzsCompression)
        else DZSSaveZ80(fName, zstate, dzsCompression);
      end
      else if LowerCase(ExtractFileExt(fName)) = '.sna' then DZSSaveSNA(fName, zstate)
      else DZSSaveToFile(fName, zstate, dzsCompression);
    except on e: Exception do
      begin
        WriteLn('***SAVING ERROR: [', e.ClassName, '] ', e.Message);
      end;
    end;
  finally
    DZSFreeStateRec(zstate);
  end;
end;

procedure CmdShowKeyHelp (const cmd: string; const args: array of string);
var
  newKeys: Boolean;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('show/hide keyboard help.');
    WriteLn('usage: show_key_help [tan|ona]');
    exit;
  end;

  newKeys := ConGetArgBoolDef(1, args, not emuShowKeyHelp);
  if newKeys = emuShowKeyHelp then exit;

  if newKeys then
  begin
    emuSavedBorderColor := emuBorderColor; emuBorderColor := 0;
    ConExecute('pause tan');
  end
  else emuBorderColor := emuSavedBorderColor;
  emuShowKeyHelp := newKeys;
  (*if winDesktop.FirstWindow = nil then *)
  EmuRenderScreen();
end;

procedure CmdSaveScrShot (const cmd: string; const args: array of string);
var
  f: Integer;
  s: string;
  fo: TFilestream;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('show/hide keyboard help.');
    WriteLn('usage: scr_shot [filename]');
    exit;
  end;

  s := ConGetArgStr(1, args);
  if s = '' then
  begin
    f := 0;
    repeat
      Str(f:3, s); s := 'sshot'+StringReplace(s, ' ', '0', [rfReplaceAll])+'.scr';
      if FileExists(s) then Inc(f) else break;
    until false;
  end;

  try
    fo := CreateFileStream(s);//TFilestream.Create(s, fmCreate);
    try
      fo.WriteBuffer(emuMemory[emuScreenPage], 6912);
    finally
      fo.Free();
    end;
    WriteLn('"', s, '" saved...');
  except on e: Exception do
    WriteLn('***SAVING ERROR: [', e.ClassName, '] ', e.Message);
  end;
end;

procedure CmdLoad (const cmd: string; const args: array of string);
var
  sn: string;
  f, c: Integer;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('load snapshot, screen, disk image.');
    WriteLn('usage: load [disk] [filename]');
    exit;
  end;

  c := 1; f := ConGetArgDisk(1, args); if (f < 0) or (f > 3) then f := 0 else Inc(c);
  sn := ConGetArgStr(c, args);
  if sn = '' then
  begin
    sn := EmuDialogGetSnapshotToLoad();
    WaitKeybRelease();
    if sn = '' then exit;
  end;

  if ExtractFileExt(sn) = '' then sn := sn+'.dzs';
  LoadSnap(sn, f);
end;

procedure CmdSave (const cmd: string; const args: array of string);
var
  sn: string;
  quick: Boolean;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('save snapshot.');
    WriteLn('usage: save [/f] [filename]');
    WriteLn('  f: save current .SLT levels');
    exit;
  end;

  quick := false;
  //if Length(args) < 1 then begin WriteLn('wtf?!'); exit; end;
  sn := ConGetArgStr(1, args);
  if sn = '/f' then begin quick := true; sn := ConGetArgStr(2, args); end;
  if sn = '' then
  begin
    sn := EmuDialogGetSnapshotToSave();
    WaitKeybRelease();
    if sn = '' then exit;
  end;

  if ExtractFileExt(sn) = '' then sn := sn+'.dzs';
  SaveSnap(sn, quick);
end;

procedure CmdScale (const cmd: string; const args: array of string);
var
  newScale: Integer;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('set screen scale factor.');
    WriteLn('usage: scale [1|2]');
    exit;
  end;

  if ConGetArgCount(args) = 0 then newScale := 3-emuScale
  else
  begin
    newScale := ConGetArgIntDef(1, args, 0);
    if (newScale < 1) or (newScale > 2) then begin WriteLn('invalid scale factor'); exit; end;
  end;

  //if emuFullScreen then WriteLn('no scaling in fullscreen mode')
  //else
  begin
    ConExecute('temp_pause tan');
    CreateEmuWindow(emuFullScreen, newScale);
    WriteLn('scale factor: ', emuScale);
    EmuRenderScreenNoInv();
    EmuDrawScreen();
    ConExecute('temp_pause ona');
  end;
end;

procedure CmdFullscreen (const cmd: string; const args: array of string);
var
  newFS: Boolean;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn('set/reset/toggle fullscreen mode.');
    WriteLn('usage: fullscreen [tan|ona]');
    exit;
  end;

  newFS := ConGetArgBoolDef(1, args, not emuFullScreen);
  if newFS = emuFullScreen then exit;

  ConExecute('temp_pause tan');
  CreateEmuWindow(newFS, emuScale);
  EmuRenderScreenNoInv();
  EmuDrawScreen();
  ConExecute('temp_pause ona');
end;

procedure CmdMouseLock (const cmd: string; const args: array of string);
var
  newML: Boolean;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn('set/reset/toggle mouse locking.');
    WriteLn('usage: mouse_lock [tan|ona]');
    exit;
  end;

  newML := ConGetArgBoolDef(1, args, not emuFullScreen);
  if newML = emuMouseLocked then exit;
  if newML then EmuUnlockMouse() else EmuLockMouse();
end;

procedure CmdTrXCheckSum (const cmd: string; const args: array of string);
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn('set/reset/toggle hobeta sum checking.');
    WriteLn('usage: trx-checksum [tan|ona]');
    exit;
  end;

  trxCheckSum := ConGetArgBoolDef(1, args, not trxCheckSum);
  Write('hobeta sum checking: ');
  if trxCheckSum then Write('tan') else Write('ona');
  WriteLn;
end;

procedure CmdInsertEmptyDisk (const cmd: string; const args: array of string);
var
  f: Integer;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn('insert empty disk in drive.');
    WriteLn('usage: empty_disk [drive]');
    exit;
  end;

  f := ConGetArgDisk(1, args); if (f < 0) or (f > 3) then f := 0;

  emuDisks.disks[f].Eject();
  emuDisks.disks[f].EmptyDisk();
  emuDisks.disks[f].SetDirty(false);
  WriteLn('empty disk in drive ', chr(ord('A')+f), ':');
end;

procedure CmdDirtyFlag (const cmd: string; const args: array of string);
const
  dc: array [Boolean] of string = ('clean', 'dirty');
var
  f, c: Integer;
  dval: Boolean;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('set/reset "dirty" flag.');
    WriteLn('usage: disk_dirty [drive] [tan|ona]');
    WriteLn('if no second arg was given, "tan" assumed.');
    exit;
  end;

  c := 1; f := ConGetArgDisk(1, args); if (f < 0) or (f > 3) then f := 0 else Inc(c);

  dval := ConGetArgBoolDef(c, args, true);
  emuDisks.disks[f].SetDirty(dval);

  WriteLn('disk in drive ', chr(ord('A')+f), ' is now ', dc[dval]);
end;

procedure CmdAddBoot (const cmd: string; const args: array of string);
var
  f, dsk: Integer;
  forced: Boolean;
  s: string;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('add boot to disk.');
    WriteLn('usage: add_boot [/f] [drive]');
    WriteLn('   /f: force boot adding');
    exit;
  end;

  dsk := 0; forced := false;
  for f := 0 to High(args) do
  begin
    s := UpperCase(args[f]);
    if s = '/F' then forced := true
    else if s = 'A:' then dsk := 0
    else if s = 'B:' then dsk := 1
    else if s = 'C:' then dsk := 2
    else if s = 'D:' then dsk := 3
    else
    begin
      WriteLn('wtf?');
      exit;
    end;
  end;
  //f := ConGetArgDisk(1, args); if (f < 0) or (f > 3) then f := 0;
  emuDisks.disks[dsk].AddStdBoot(forced);
  WriteLn('disk in drive ', chr(ord('A')+dsk), ' is now bootable');
end;

procedure CmdActivateDebugger (const cmd: string; const args: array of string);
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('activate debugger.');
    WriteLn('usage: activate_debugger');
    exit;
  end;

  if not emuDbgActive then exit;
  emuSingleStep := true;
end;

procedure CmdNMI (const cmd: string; const args: array of string);
// !!!FIXME: tick count
var
  trd: Boolean;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('generate NMI.');
    WriteLn('usage: nmi [trdos]');
    exit;
  end;

  if emuZ80.regPC < $4000 then exit; // like the "MAGIC BUTTON"

  trd := (Copy(ConGetArgStr(1, args), 1, 2) = 'tr');

  if trd then
  begin
    Write('TR-DOS ');
    emuPaging[0] := 10; // swap in TR-DOS
  end;

  WriteLn('NMI');
  Z80Push(emuZ80, emuZ80.regPC);
  emuZ80.iff1 := false;
  emuZ80.iff2 := false;
  emuZ80.regPC := $66;
  emuZ80.orgPC := $66;
  Inc(emuZ80.tStates, 11); //???
end;

procedure CmdTape (const cmd: string; const args: array of string);
var
  s: string;
  f, c, p: Integer;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('tape operations.');
    WriteLn('usage: tape [mode [args]]');
    WriteLn(#0#1#1'if no "mode" given, the playing state will be toggled.');
    WriteLn(' mode:');
    WriteLn('  r[ewind] [block_number]');
    WriteLn('  skip(k) [block_count] -- can be negative');
    WriteLn('  p[lay]');
    WriteLn('  s[top]');
    WriteLn('  l[ist] -- list blocks');
    WriteLn('  w[here] -- current tape position');
    WriteLn('  g[o] addr -- go to the new tape position');
    WriteLn('  p(e)ek addr -- "peek" tape');
    WriteLn('  u[nload] -- unload tape');
    exit;
  end;

  if ConGetArgCount(args) = 0 then
  begin
    if emuTapeInfo.playing then EmuStopTape(true) else EmuStartTape(true);
    exit;
  end;

  s := ConGetArgStr(1, args);
  if (s = 'stop') or (s = 's') then EmuStopTape(true)
  else if (s = 'play') or (s = 'p') then EmuStartTape(true)
  else if (s = 'rewind') or (s = 'r') then
  begin
    if Length(args) = 1 then EmuRewindTape()
    else
    begin
      if not ConStr2Int(args[1], f) then begin WriteLn('invalid number!'); exit; end;
      EmuTapeGoToBlock(f);
    end;
  end
  else if (s = 'unload') or (s = 'u') then
  begin
    EmuStopTape(true);
    emuTapeInfo.tape.Clear();
  end
  else if (s = 'skip') or (s = 'k') then
  begin
    if Length(args) = 1 then f := 1
    else
    begin
      if not ConStr2Int(args[1], f) then begin WriteLn('invalid number!'); exit; end;
    end;
    EmuTapeSkipBlocks(f);
  end
  else if (s = 'where') or (s = 'w') then
  begin
    Write('tape pos: ', emuTapeInfo.tape.Position);
    if emuTapeInfo.tape.Count > 0 then
      Write(' (', emuTapeInfo.tape.Position*100 div emuTapeInfo.tape.Count, '%)');
    WriteLn;
  end
  else if (s = 'go') or (s = 'goto') or (s = 'g') then
  begin
    if (Length(args) < 2) or not ConStr2Int(args[1], f) then begin WriteLn('invalid number!'); exit; end;
    emuTapeInfo.tape.Position := f;
  end
  else if (s = 'peek') or (s = 'e') then
  begin
    if (Length(args) < 2) or not ConStr2Int(args[1], f) then begin WriteLn('invalid number!'); exit; end;
    WriteLn(f, '=', emuTapeInfo.tape[f]);
  end
  else if (s = 'list') or (s = 'l') then
  begin
    WriteLn('tape blocks:'); c := 0;
    for f := 0 to emuTapeInfo.tape.Count-1 do
    begin
      p := emuTapeInfo.tape[f];
      if (p = -660) or (p = -3) or (p = -2) or (p = -1) then
      begin
        //WriteLn(' ', c, ': pos=', f);
        Inc(c);
      end;
      case p of
        -667: WriteLn(' ', c, ': pause block; pos=', f, ' (', f*100 div emuTapeInfo.tape.Count, '%)');
        -666: WriteLn(' ', c, ': standard block; pos=', f, ' (', f*100 div emuTapeInfo.tape.Count, '%)');
        -665: WriteLn(' ', c, ': direct block; pos=', f, ' (', f*100 div emuTapeInfo.tape.Count, '%)');
        -664: WriteLn(' ', c, ': pure data block; pos=', f, ' (', f*100 div emuTapeInfo.tape.Count, '%)');
        -663: WriteLn(' ', c, ': pulses block; pos=', f, ' (', f*100 div emuTapeInfo.tape.Count, '%)');
        -662: WriteLn(' ', c, ': pure tone block; pos=', f, ' (', f*100 div emuTapeInfo.tape.Count, '%)');
        -661: WriteLn(' ', c, ': turbo block; pos=', f, ' (', f*100 div emuTapeInfo.tape.Count, '%)');
        -3: WriteLn(' ', c, ': stop if 128K; pos=', f, ' (', f*100 div emuTapeInfo.tape.Count, '%)');
        -2: WriteLn(' ', c, ': stop; pos=', f, ' (', f*100 div emuTapeInfo.tape.Count, '%)');
        -1: WriteLn(' ', c, ': stop if 48K; pos=', f, ' (', f*100 div emuTapeInfo.tape.Count, '%)');
      end;
      if p <= -1000 then
      begin
        p := (-p)-1000;
        if p < emuTapeInfo.tape.Messages.Count then
          WriteLn(' ', c, ': "', emuTapeInfo.tape.Messages[p], '"')
        else WriteLn('  msg no ', p);
      {end
      else if (p = -660) or (p = -3) or (p = -2) or (p = -1) then
      begin
        //WriteLn(' ', c, ': pos=', f);
        Inc(c);}
      end;
    end;
    WriteLn('end of tape: ', emuTapeInfo.tape.Count);
  end
  else WriteLn('wtf?');
end;

procedure CmdSaveDisk (const cmd: string; const args: array of string);
var
  s: string;
  f: Integer;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('save disk.');
    WriteLn('usage: save_disk [drive] name');
    exit;
  end;

  if ConGetArgCount(args) = 0 then
  begin
    WriteLn('wtf?');
    exit;
  end;

  f := ConGetArgDisk(1, args);
  if (f < 0) or (f > 3) then
  begin
    f := 0;
    s := ConGetArgStr(1, args);
  end
  else s := ConGetArgStr(2, args);

  if s = '' then
  begin
    WriteLn('name?');
    exit;
  end;

  if ExtractFileExt(s) = '' then s := s+'.trd';

  WriteLn('"', s, '"');
  Write('saving disk from drive ', chr(ord('A')+f), ':');
  try
    emuDisks.disks[f].SaveToFile(s);
    WriteLn(' -- ok');
  except on e: Exception do
    begin
      WriteLn(' -- failed!');
      WriteLn('error ', e.ClassName, ': "', e.Message, '"');
    end;
  end;
end;


procedure CmdRegs (const cmd: string; const args: array of string);
const
  flg: array [Boolean, 0..7] of Char = ('sz.h.pnc', 'SZ5H3PNC');
var
  b0: Byte;
  f: Integer;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('show register values.');
    WriteLn('usage: regs');
    exit;
  end;

  WriteLn;
  Write('af:', IntToHex(Z80GetAF(emuZ80), 4));
  Write(' af''', IntToHex(emuZ80.regAFx, 4));
  Write(' sp:', IntToHex(emuZ80.regSP, 4));
  WriteLn(' ir:', IntToHex(emuZ80.regI, 2),
    IntToHex((emuZ80.regR and $80) or (emuZ80.regRTemp and $7F), 2));
  Write('bc:', IntToHex(Z80GetBC(emuZ80), 4));
  Write(' bc''', IntToHex(emuZ80.regBCx, 4));
  Write(' pc:', IntToHex(emuZ80.regPC, 4));
  WriteLn(' t:', emuZ80.tStates:5);
  Write('de:', IntToHex(emuZ80.regDE, 4));
  Write(' de''', IntToHex(emuZ80.regDEx, 4));
  Write(' ix:', IntToHex(emuZ80.regIX, 4));
  Write(' im:', emuZ80.im);
  Write(',i:');
  if emuZ80.iff1 then Write('1') else Write('0');
  if emuZ80.iff2 then Write('1') else Write('0');
  WriteLn;
  Write('hl:', IntToHex(emuZ80.regHL, 4));
  Write(' hl''', IntToHex(emuZ80.regHLx, 4));
  Write(' iy:', IntToHex(emuZ80.regIY, 4), ' ');

  b0 := Z80GetF(emuZ80);
  for f := 0 to 7 do
  begin
    Write(flg[(b0 and $80) <> 0, f]); b0 := (b0 and $7F) shl 1;
  end;
  WriteLn;

  {WriteLn('im: ', emuZ80.im, ' iff1:', ConYesNoName(emuZ80.iff1),
    ' iff2:', ConYesNoName(emuZ80.iff2), '  ts: ', emuZ80.tStates);}
end;

procedure CmdAlter (const cmd: string; const args: array of string);
var
  val, c: Integer;
  s: string;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('alter register value.');
    WriteLn('usage: alter reg value');
    WriteLn('reg: A,B,C,D,E,H,L,F,AF,BC,DE,HL,SP,PC,IX,IY');
    WriteLn('     AF'',BC'',DE'',HL''');
    WriteLn('     I,R');
    WriteLn('     TS: set t-states');
    WriteLn('     IFF: set iff1 & iff2 (only 0 or 1)');
    WriteLn('     IFF1, IFF2');
    WriteLn('     IM: set intr. mode (0, 1 or 2)');
    exit;
  end;

  if ConGetArgCount(args) < 2 then begin WriteLn('wtf?'); exit; end;

  s := UpperCase(ConGetArgStr(1, args));
  val := ConGetArgIntDef(2, args, -1);
  if val < 0 then begin WriteLn('number?'); exit; end;

  if s = 'TS' then
  begin
    if val > emuTicksIntr then begin WriteLn('value?'); exit; end;
    emuZ80.tStates := val;
    WriteLn('t-states: ', val);
    exit;
  end
  else if s = 'IM' then
  begin
    if val > 2 then begin WriteLn('value?'); exit; end;
    emuZ80.im := val;
    WriteLn('im: ', val);
    exit;
  end
  else if (s = 'IFF') or (s = 'IFF1') or (s = 'IFF2') then
  begin
    if val > 1 then begin WriteLn('value?'); exit; end;
    if (s = 'IFF') or (s = 'IFF1') then emuZ80.iff1 := val <> 0;
    if (s = 'IFF') or (s = 'IFF2') then emuZ80.iff2 := val <> 0;
    WriteLn(LowerCase(s), ': ', ConYesNoName(val <> 0));
    exit;
  end;

  if val > 65535 then begin WriteLn('number?'); exit; end;

  s := UpperCase(ConGetArgStr(1, args));
  if Length(s) > 3 then begin WriteLn('what?'); exit; end;

  if Length(s) = 1 then begin val := val and $FF; c := 2; end else c := 4;
  if s = 'A' then emuZ80.regA := val
  else if s = 'F' then Z80SetF(emuZ80, val)
  else if s = 'B' then emuZ80.regB := val
  else if s = 'C' then emuZ80.regC := val
  else if s = 'D' then emuZ80.regDE := (emuZ80.regDE and $00FF) or (val shl 8)
  else if s = 'E' then emuZ80.regDE := (emuZ80.regDE and $FF00) or val
  else if s = 'H' then emuZ80.regHL := (emuZ80.regHL and $00FF) or (val shl 8)
  else if s = 'L' then emuZ80.regHL := (emuZ80.regHL and $FF00) or val
  else if s = 'AF' then Z80SetAF(emuZ80, val)
  else if s = 'BC' then Z80SetBC(emuZ80, val)
  else if s = 'DE' then emuZ80.regDE := val
  else if s = 'HL' then emuZ80.regHL := val
  else if s = 'IX' then emuZ80.regIX := val
  else if s = 'IY' then emuZ80.regIY := val
  else if s = 'SP' then emuZ80.regSP := val
  else if s = 'PC' then emuZ80.regPC := val
  else if s = 'I' then emuZ80.regI := val
  else if s = 'R' then
  begin
    emuZ80.regR := val and $80; emuZ80.regRTemp := (val and $7F);
  end
  else if s = 'AF''' then emuZ80.regAFx := val
  else if s = 'BC''' then emuZ80.regBCx := val
  else if s = 'DE''' then emuZ80.regDEx := val
  else if s = 'HL''' then emuZ80.regHLx := val
  else
  begin
    WriteLn('register?'); exit;
  end;

  WriteLn(LowerCase(s), ': #', IntToHex(val, c), ' (', val, ')');
end;


function ConStr2IntDef (const s: string; def: Integer): Integer;
begin
  if not ConStr2Int(s, result) then result := def;
end;


var
  lastUnasmAddr: Integer = 0;

{$I-}
procedure CmdUnasm (const cmd: string; const args: array of string);
var
  f, c, addr: Integer;
  ui: TUnasmInfo;
  s, fo, t: string;
  ft: TextFile;
  len, eaddr: Integer;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('disassemble.');
    WriteLn('usage: unasm [addr] [o=filename] [l=cmdcount]');
    WriteLn('  [e=endaddr] -- will not be included in the dump');
    exit;
  end;

  fo := ''; len := -1; eaddr := -1; addr := lastUnasmAddr;
  for f := 0 to High(args) do
  begin
    s := args[f];
    if (Length(s) > 2) and (s[1] = 'o') and (s[2] = '=') then
    begin
      fo := Copy(s, 3, Length(s));
      if ExtractFileExt(fo) = '' then fo := fo+'.lst';
      continue;
    end;

    if (Length(s) > 2) and (s[1] = 'l') and (s[2] = '=') then
    begin
      s := Copy(s, 3, Length(s));
      c := ConStr2IntDef(s, -1);
      if c < 1 then
      begin
        WriteLn('invalid length: ', s);
        exit;
      end;
      len := c;
      continue;
    end;

    if (Length(s) > 2) and (s[1] = 'e') and (s[2] = '=') then
    begin
      s := Copy(s, 3, Length(s));
      c := ConStr2IntDef(s, -1);
      if c > 65536 then
      begin
        WriteLn('invalid end address: ', s);
        exit;
      end;
      eaddr := c;
      continue;
    end;

    c := ConStr2IntDef(s, -1);
    if c > 65535 then
    begin
      WriteLn('invalid start address: ', s);
      exit;
    end;
    addr := c;
  end;

  if (eaddr <> -1) and (eaddr <= addr) then
  begin
    WriteLn('invalid address range: ', addr, ' -- ', eaddr);
    exit;
  end;

  if fo <> '' then
  begin
    IOResult();
    AssignFile(ft, fo);
    Append(ft);
    if IOResult() <> 0 then Rewrite(ft);
    if IOResult() <> 0 then fo := '';
  end;

  if eaddr = -1 then
  begin
    if len = -1 then len := 12;
  end;
  addr := addr and $FFFF;
  repeat
    ZCmdDecode(addr, ui);

    s := ui.cmdName;
    if ui.argC > 0 then
    begin
      while Length(s) < 5 do s := s+' ';
      s := s+ui.args[0];
      for c := 1 to 2 do
        if c < ui.argC then s := s+','+ui.args[c];
    end;

    t := IntToHex(ui.addr, 4)+' ';
    for c := 0 to ui.len-1 do t := t+IntToHex(ui.dump[c], 2)+' ';
    for c := ui.len to 5 do t := t+'   ';
    t := t+' '+s;

    WriteLn(t);
    if fo <> '' then WriteLn(ft, t);

    Inc(addr, ui.len);
    if (eaddr <> -1) and (addr >= eaddr) then break;
    if len > 0 then Dec(len);
    addr := addr and $FFFF;

    if len = 0 then break;
    if len > 0 then Dec(len);
    if (eaddr <> -1) and (addr >= eaddr) then break;
  until false;//(len = 0) or (addr >= eaddr);
  if fo <> '' then CloseFile(ft);

  lastUnasmAddr := addr;
end;

procedure CmdLoadBP (const cmd: string; const args: array of string);
var
  fn: string;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('load breakpoints.');
    WriteLn('usage: loadbp [filename]');
    exit;
  end;

  fn := ConGetArgStr(1, args);
  if fn = '' then fn := 'dspdef';
  try
    DbgLoadBPs(fn);
  except on e: Exception do
    WriteLn('***LOADING ERROR: [', e.ClassName, '] ', e.Message);
  end;
end;

procedure CmdSaveBP (const cmd: string; const args: array of string);
var
  fn: string;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('save breakpoints.');
    WriteLn('usage: savebp [filename]');
    exit;
  end;

  fn := ConGetArgStr(1, args);
  if fn = '' then fn := 'dspdef';
  try
    DbgSaveBPs(fn);
  except on e: Exception do
    WriteLn('***SAVING ERROR: [', e.ClassName, '] ', e.Message);
  end;
end;

procedure CmdBP (const cmd: string; const args: array of string);
var
  f, addr: Integer;
  s: string;
  mode: Integer;
begin
  if ConIsArgHelp(args) or (Length(args) < 1) then
  begin
    WriteLn;
    WriteLn('set/reset/toggle breakpoints.');
    WriteLn('usage: bp [set|res[et]|cle[ar]] [addrlist]');
    exit;
  end;

  s := LowerCase(args[0]);
  if (s = 'cle') or (s = 'clear') then
  begin
    DbgClearBPs();
    WriteLn('breakpoints cleared');
    exit;
  end;

  mode := -1;
  if s = 'set' then mode := 1
  else if s = 'reset' then mode := 0
  else if s = 'res' then mode := 0;
  if mode <> -1 then f := 1 else f := 0;

  while f < Length(args) do
  begin
    if not ConStr2Int(args[f], addr) then
    begin
      WriteLn('wtf is "', args[f], '"?');
      //exit;
    end
    else
    begin
      if mode = 0 then DbgResetBP(addr)
      else if mode = 1 then DbgSetBP(addr)
      else DbgToggleBP(addr);
    end;
    Inc(f);
  end;
end;

procedure CmdAsm (const cmd: string; const args: array of string);
var
  f: Integer;
  s: string;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('assemble line.');
    WriteLn('usage: asm line');
    WriteLn('ACHTUNG! you''d better set ORG before asm');
    WriteLn('you can say "asm org pc"');
    exit;
  end;

  s := '';
  for f := 0 to High(args) do s := s+' '+args[f];
  f := 1;
  while f <= Length(s) do
  begin
    if s[f] in ['"',#39,'!'] then begin Insert('!', s, f); Inc(f); end;
    Inc(f);
  end;
  ConExecute(':(assemble-str "'+s+'")');
end;

procedure CmdLabels (const cmd: string; const args: array of string);
var
  s: string;
  sys: Boolean;
  addr, f, sz: Integer;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('load/clear/... labels');
    WriteLn('usage: labels command [args]');
    WriteLn('commands:');
    WriteLn('  a[dd] [sys] addr name [size] -- add label');
    WriteLn('  c[clear] [sys] -- clear labels');
    WriteLn('  l[oad] [sys] filename[.map] -- load labels');
    WriteLn('"sys" means "system" labels. so you can');
    WriteLn('load "system" labels once and then alter');
    WriteLn('"user" labels w/o clearing the "system" ones');
    exit;
  end;

  if Length(args) < 1 then begin WriteLn('wtf?'); exit; end;
  if Length(args) > 1 then sys := (args[1] = 'sys') else sys := false;
  s := args[0];
  if (s = 'c') or (s = 'clear') then
  begin
    ZClearLabels(sys);
    if sys then Write('system '); WriteLn('labels cleared.');
  end
  else if (s = 'l') or (s = 'load') then
  begin
    if (sys and (Length(args) < 3)) or (not sys and (Length(args) < 2)) then begin WriteLn('wtf?'); exit; end;
    if sys then s := args[2] else s := args[1];
    s := StringReplace(s, '/', '\', [rfReplaceAll]);
    if ExtractFileExt(s) = '' then s := s+'.map';
    if not FileExists(s) then
    begin
      s := FileSearchEx(s, '.;$(appdir)');
    end;
    if s = '' then begin WriteLn('no file!'); exit; end;
    WriteLn('map file: "', s, '"');
    try
      ZLoadLabels(s, sys);
      if sys then Write('system '); WriteLn('labels loaded.');
    except
      WriteLn('file error!');
    end;
  end
  else if (s = 'a') or (s = 'add') then
  begin
    if (sys and (Length(args) < 4)) or (not sys and (Length(args) < 3)) then begin WriteLn('wtf?'); exit; end;
    if sys then s := args[2] else s := args[1];
    if not ConStr2Int(s, addr) then begin WriteLn('invalid address!'); exit; end;
    if (addr < 0) or (addr > 65535) then begin WriteLn('invalid address!'); exit; end;
    if sys then s := args[3] else s := args[2]; // name
    if sys then f := 4 else f := 3;
    if f < Length(args) then
    begin
      if not ConStr2Int(args[f], sz) then begin WriteLn('invalid size!'); exit; end;
      if (sz < 0) or (sz > 65535) then begin WriteLn('invalid size!'); exit; end;
    end
    else sz := 0;
    try
      ZAddLabel(s, addr, sz, sys);
      if sys then Write('system '); WriteLn('label added:');
      WriteLn('  "', s, '": #', IntToHex(addr, 4), '; sz=', sz);
    except
      WriteLn('error!');
    end;
  end
  else WriteLn('wtf?');
end;

procedure CmdLispTraps (const cmd: string; const args: array of string);
var
  s: string;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('turn #ED/#06 traps on/off.');
    WriteLn('usage: lisp-traps [tan|ona]');
    exit;
  end;

  if Length(args) > 0 then
  begin
    s := args[0];
    if (s = 't') or (s = 'tan')  then doED06Traps := true
    else if (s = 'o') or (s = 'ona') then doED06Traps := false
    else begin WriteLn('wtf?'); exit; end;
  end
  else doED06Traps := not doED06Traps;

  Write('#ED/#06 lisp traps: ');
  if doED06Traps then WriteLn('tan') else WriteLn('ona');
end;

procedure CmdSnapCompress (const cmd: string; const args: array of string);
var
  s: string;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn;
    WriteLn('set compression for DZS/Z80.');
    WriteLn('usage: snap-compress <mode>');
    WriteLn('modez:');
    WriteLn('  n[o],o[na] -- no compression at all');
    WriteLn('  r[le] -- rle compression');
    WriteLn('  x -- xpack (rle for Z80)');
    WriteLn('  w[dx],t[an] -- wdxpack (rle for Z80)');
    exit;
  end;

  if Length(args) > 0 then
  begin
    s := args[0];
    if (s = 'n') or (s = 'no') or (s = 'o') or (s = 'ona') then dzsCompression := dzsPackNo
    else if (s = 'r') or (s = 'rle') then dzsCompression := dzsPackRLE
    else if s = 'x' then dzsCompression := dzsPackX
    else if (s = 'w') or (s = 'wdx') or (s = 't') or (s = 'tan') then dzsCompression := dzsPackW
    else begin WriteLn('wtf?'); exit; end;
  end;

  Write('snapshot compression: ');
  case dzsCompression of
    dzsUnpacked: Write('ona');
    dzsPackRLE: Write('rle');
    dzsPackX: Write('x');
    dzsPackW: Write('wdx');
    else Write('??? (', dzsCompression, ')');
  end;
  WriteLn;
end;

procedure CmdShowFPS (const cmd: string; const args: array of string);
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn('show/hide FPS counter.');
    WriteLn('usage: showfps [tan|ona]');
    exit;
  end;

  emuShowFPS := ConGetArgBoolDef(1, args, not emuShowFPS);
end;

procedure CmdUseDDraw (const cmd: string; const args: array of string);
var
  newDD: Boolean;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn('use ddraw or gdi.');
    WriteLn('usage: use-ddraw [tan|ona]');
    exit;
  end;

  newDD := ConGetArgBoolDef(1, args, not emuUseDDraw);
  if newDD = emuUseDDraw then exit;
  if newDD and not IsDDrawHere() then
  begin
    WriteLn('DirectDraw7 is not here...');
    exit;
  end;
  emuUseDDraw := newDD;
  ConExecute('temp_pause tan');
  CreateEmuWindow(emuFullScreen, emuScale);
  EmuRenderScreenNoInv();
  EmuDrawScreen();
  ConExecute('temp_pause ona');
end;

procedure CmdDDrawHWScale (const cmd: string; const args: array of string);
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn('ddraw hardware scaling.');
    WriteLn('usage: ddraw-hwscale [tan|ona]');
    exit;
  end;

  ddrawScaleHW := ConGetArgBoolDef(1, args, not ddrawScaleHW);
  EmuDrawScreen();
  Write('ddraw hw scale: ');
  if ddrawScaleHW then WriteLn('tan') else WriteLn('ona');
end;

procedure CmdDisableTurtle (const cmd: string; const args: array of string);
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn('show turtle?');
    WriteLn('usage: disable-turtle [tan|ona]');
    exit;
  end;

  emuNoTurtle := ConGetArgBoolDef(1, args, not emuNoTurtle);
  Write('turtle: ');
  if not emuNoTurtle then WriteLn('tan') else WriteLn('ona');
end;

function DZSKillLisp (state: PDZSZ80State): Boolean;
var
  pblk, blk: PDZSMemBlock;
begin
  result := false;
  if state = nil then exit;
  pblk := nil; blk := state.unkBlocks;
  while blk <> nil do
  begin
    if IsLispBlock(blk) then
    begin
      if pblk = nil then state.unkBlocks := blk.next
      else pblk.next := blk.next;
      blk.data := nil; Dispose(blk);
      if pblk = nil then blk := state.unkBlocks else blk := pblk.next;
      result := true;
    end
    else begin pblk := blk; blk := blk.next; end;
  end;
end;

function DZSFindLisp (state: PDZSZ80State): PDZSMemBlock;
var
  blk: PDZSMemBlock;
begin
  result := nil; if state = nil then exit;
  blk := state.unkBlocks;
  while blk <> nil do
  begin
    if IsLispBlock(blk) then result := blk;
    blk := blk.next;
  end;
end;

procedure CmdDZSLispClear (const cmd: string; const args: array of string);
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn('delete embedded lisp from DZS snapshot');
    WriteLn('usage: dzs-lisp-clear');
    exit;
  end;

  if DZSKillLisp(lastSnapState) then WriteLn('embedded lisp destroyed.');
end;

procedure CmdDZSLispAdd (const cmd: string; const args: array of string);
var
  s: string;
  fi: TFileStream;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn('add embedded lisp to DZS snapshot');
    WriteLn('usage: dzs-lisp-add [filename]');
    exit;
  end;

  if Length(args) > 0 then s := args[0] else s := lastSnapLisp;
  if s = '' then
  begin
    WriteLn('shit. what file?');
    exit;
  end;

  s := StringReplace(s, '/', '\', [rfReplaceAll]);
  if ExtractFileExt(s) = '' then s := s+'.l';

  fi := nil;
  try
    fi := TFileStream.Create(s, fmOpenRead or fmShareDenyWrite);
    WriteLn('adding lisp from "', s, '"');
    if lastSnapState = nil then lastSnapState := DZSNewStateRec()
    else DZSKillLisp(lastSnapState);
    SetLength(s, fi.Size); UniqueString(s);
    if s <> '' then
    begin
      fi.ReadBuffer(s[1], Length(s));
      s := 'k8DSPemuLSP3'#0+s;
      DZSNewUnkBlock(lastSnapState, 13, s[1], Length(s));
    end;
    FreeAndNil(fi);
  except
    fi.Free();
    WriteLn('shit. file error.');
  end;
end;

procedure CmdDZSLispSave (const cmd: string; const args: array of string);
var
  s: string;
  fi: TFileStream;
  blk: PDZSMemBlock;
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn('save embedded lisp to DZS snapshot');
    WriteLn('usage: dzs-lisp-save [filename]');
    exit;
  end;

  blk := DZSFindLisp(lastSnapState);
  if blk = nil then begin WriteLn('shit. no embedded lisp.'); exit; end;

  if Length(args) > 0 then s := args[0] else s := lastSnapLisp;
  if s = '' then
  begin
    WriteLn('shit. what file?');
    exit;
  end;

  s := StringReplace(s, '/', '\', [rfReplaceAll]);
  if ExtractFileExt(s) = '' then s := s+'.l';

  fi := nil;
  try
    fi := CreateFileStream(s);//TFileStream.Create(s, fmCreate);
    WriteLn('saving lisp to "', s, '"');
    SetLength(s, Length(blk.data)-13); UniqueString(s);
    if s <> '' then
    begin
      Move(blk.data[13], s[1], Length(s));
      fi.WriteBuffer(s[1], Length(s));
    end;
    FreeAndNil(fi);
  except
    fi.Free();
    WriteLn('shit. file error.');
  end;
end;

procedure CmdShowMainLogo (const cmd: string; const args: array of string);
begin
  if ConIsArgHelp(args) then
  begin
    WriteLn('show/hide main logo window.');
    WriteLn('usage: show-main-logo [tan|ona]');
    exit;
  end;

  showMainLogo := ConGetArgBoolDef(1, args, not showMainLogo);
  if showMainLogo then
  begin
    if logoWH = 0 then CreateMainLogoWindow();
  end
  else
  begin
    if logoWH <> 0 then PostMessage(logoWH, WM_CLOSE, 0, 0);
  end;
end;


procedure LispED06Trap (z80cpu: PZ80CPU);
var
  s: string;
begin
  if not doED06Traps then exit;
  s := IntToStr(z80cpu.regPC)+')';
  ALispEvalStr('(ed06-trap '+s);
  ALispEvalStr('(ed06-trap-done '+s);
end;

procedure SLTTrap (z80cpu: PZ80CPU);
// .SLT trap (#ED/#FB)
//  HL: address to load;
//  A: level number
//  return: CARRY complemented --> error
// addr should be taken from z80cpu.regPC
// it points to the byte right after #FB
var
  (*res: Integer;
  s: string;*)
  //fo: TFileStream;
  blk, blkf: PDZSMemBlock;
  f: Integer;
  ad: Word;
begin
  if z80cpu.regPC < 16384 then exit; // no traps in ROM

  (*s := ' '+IntToStr(z80cpu.regHL)+' '+IntToStr(z80cpu.regA)+' '+
    IntToStr(z80cpu.regPC)+')';
  res := ALispEvalStr('(slt-trap'+s);
  if ALErrorFlag() then res := ALNil();
  if ALIsNil(res) or ALIsFalse(res) then z80cpu.flagC := not z80cpu.flagC;
  ALispEvalStr('(slt-trap-done'+s);*)

  WriteLn('.SLT: loading block ', z80cpu.regA);
  blkf := nil;
  if lastSnapState <> nil then
  begin
    blk := lastSnapState.blocks;
    while blk <> nil do
    begin
      if blk.page = z80cpu.regA then blkf := blk;
      blk := blk.next;
    end;
  end;
  if blkf = nil then
  begin
    WriteLn('.SLT: level ', z80cpu.regA, ' not found');
    z80cpu.flagC := not z80cpu.flagC;
  end
  else
  begin
    ad := z80cpu.regHL;
    for f := 0 to High(blkf.data) do
    begin
      Z80PokeBInternal(z80cpu, ad, blkf.data[f]);
      ad := (ad+1) and $FFFF;
    end;
    Write('.SLT: block ', z80cpu.regA, '; ');
    WriteLn('addr=#', IntToHex(z80cpu.regHL, 4), ' (', z80cpu.regHL, '); ',
      'size=', Length(blkf.data));
    (*fo := TFileStream.Create('!.!', fmCreate);
    fo.WriteBuffer(blkf.data[0], Length(blkf.data));
    fo.Free();*)
  end;
end;


var
  s: string;
  f: Integer;
  sl: TStringList;
  systemInfo: TSystemInfo;
  li: TLargeInteger;
begin
  if not QueryPerformanceCounter(li) then
  begin
    MessageBox(0, 'CPU too weak: QueryPerformanceCounter() failed',
      'DSP TANTRUM!', MB_OK or MB_TOPMOST);
    Halt(1);
  end;

  CreateMainLogoWindow();

  HPTimerMainInit();
  CreateEmuWindow(false, 2);
  EmuRenderScreen(); EmuDrawScreen(); UpdateWindow(emuHWnd);

  Z80SaveTrap := @TapeSaveTrap;

  ALEvalStr('(clear-context-stack)');
  kOnOffMsg := RegisterWindowMessage('k8KlockOnOffMessage');

  ALSetDefPathList('.;$(appdir)\lisp;$(appdir)');

  Z80ED06Trap := LispED06Trap;
  Z80EDFBTrap := SLTTrap;

  FillChar(systemInfo, SizeOf(systemInfo), 0);
  GetSystemInfo(systemInfo);
  Write(systemInfo.dwNumberOfProcessors, ' system processor');
  if systemInfo.dwNumberOfProcessors > 1 then Write('s');
  WriteLn(' found.');

  if pcJoyCount = 0 then WriteLn('joysticks: ona')
  else
  begin
    Write(pcJoyCount, ' joysticks, active: ');
    if pcJoyActive = 0 then Write('ona')
    else if pcJoyActive = 3 then Write('two')
    else Write('one');
    WriteLn;
  end;

  {$IFDEF SHOWCPUSPEED}
  CmdShowCPUSpeed('', []);
  {$ENDIF}

  {$IFNDEF USE_HP_TIMER}
  WriteLn('creating high performance counters...');
  emuHQCounter := THQCounter.Create();
  emuFPSHQCounter := THQCounter.Create();
  WriteLn('high performance counters created');
  WriteLn;
  {$ENDIF}

  RegisterConsoleCommand('cpuspeed', @CmdShowCpuSpeed);

  RegisterConsoleCommand('quit', @CmdQuit);
  RegisterConsoleCommand('exec', @CmdLoadScript);

  RegisterConsoleCommand('loadbp', @CmdLoadBP);
  RegisterConsoleCommand('savebp', @CmdSaveBP);

  RegisterConsoleCommand('bp', @CmdBP);

  RegisterConsoleCommand('trdos_extract', @CmdTrDosExtract);
  RegisterConsoleCommand('trx-checksum', @CmdTrXCheckSum);

  RegisterConsoleCommand('show_key_help', @CmdShowKeyHelp);
  RegisterConsoleCommand('scr_shot', @CmdSaveScrShot);
  RegisterConsoleCommand('load', @CmdLoad);
  RegisterConsoleCommand('save', @CmdSave);
  RegisterConsoleCommand('scale', @CmdScale);
  RegisterConsoleCommand('fullscreen', @CmdFullscreen);
  RegisterConsoleCommand('tape', @CmdTape);
  RegisterConsoleCommand('add_boot', @CmdAddBoot);
  RegisterConsoleCommand('nmi', @CmdNMI);
  RegisterConsoleCommand('activate_debugger', @CmdActivateDebugger);
  RegisterConsoleCommand('disk_dirty', @CmdDirtyFlag);
  RegisterConsoleCommand('empty_disk', @CmdInsertEmptyDisk);
  RegisterConsoleCommand('mouse_lock', @CmdMouseLock);

  RegisterConsoleCommand('poke', @CmdPoke);
  RegisterConsoleCommand('peek', @CmdPeek);
  RegisterConsoleCommand('out', @CmdOut);
  RegisterConsoleCommand('in', @CmdIn);

  RegisterConsoleCommand('findb', @CmdFind);
  RegisterConsoleCommand('findw', @CmdFind);
  RegisterConsoleCommand('dump', @CmdDump);

  RegisterConsoleCommand('dup', @CmdDup);
  RegisterConsoleCommand('xpeek', @CmdXPeek);
  RegisterConsoleCommand('diff', @CmdDiff);

  RegisterConsoleCommand('regs', @CmdRegs);
  RegisterConsoleCommand('alter', @CmdAlter);
  RegisterConsoleCommand('unasm', @CmdUnasm);

  RegisterConsoleCommand('asm', @CmdAsm);

  RegisterConsoleCommand('save_disk', @CmdSaveDisk);

  RegisterConsoleCommand('labels', @CmdLabels);
  RegisterConsoleCommand('snap-compress', @CmdSnapCompress);

  RegisterConsoleCommand('lisp-traps', @CmdLispTraps);

  RegisterConsoleCommand('showfps', @CmdShowFPS);

  RegisterConsoleCommand('use-ddraw', @CmdUseDDraw);
  RegisterConsoleCommand('ddraw-hwscale', @CmdDDrawHWScale);

  RegisterConsoleCommand('disable-turtle', @CmdDisableTurtle);

  RegisterConsoleCommand('dzs-lisp-add', @CmdDZSLispAdd);
  RegisterConsoleCommand('dzs-lisp-clear', @CmdDZSLispClear);
  RegisterConsoleCommand('dzs-lisp-save', @CmdDZSLispSave);

  RegisterConsoleCommand('tape-out-file', @CmdTapeOutFile);
  RegisterConsoleCommand('show-main-logo', @CmdShowMainLogo);

  ConExecute('bind clear');
  ConExecute('zxbind clear');

  WriteLn('initializing ALISP...');
  //ALispEvalStr(dummyED06TrapStr);
  //ALispEvalStr(dummySLTTrapStr);
  //ALispEvalStr(dummySnapUnloadStr);
  //!DefineStdLsp();
  ClearStdLsp();
  ALispEvalStr('(load "init/init")');
  //WriteLn;

  WriteLn('loading config...');
  ConExecute('exec dsp.script');

  ZXSetModel(config.startingModel);

  ConExecute('exec autoexec.script');

  //CreateEmuWindow(false, 2);
  //EmuRenderScreen(); EmuDrawScreen();

  ALispEvalStr('(load "init/post_init")');
  //WriteLn;

  //SetCurrentDir('dzs');
  //DbgGetRegsWin();
  s := '';
  if (ParamStr(1) = '/c') or (ParamStr(1) = '-c') then
  begin
    s := GetCommandLine();
    {for f := 2 to ParamCount() do
    begin
      t := ParamStr(f);
      if Pos('"', s) <> 0 then qCh := #39
      else if Pos(' ', s) <> 0 then qCh := '"'
      else qCh := ' ';
      s := ' '+s+qch+t+qch;
    end;}
    Delete(s, 1, Pos(ParamStr(1), s)+1);
    s := Trim(s);
    if (Length(s) > 1) and (s[1] = '"') and (s[Length(s)] = '"') then
      s := Copy(s, 2, Length(s)-2)
    else if (Length(s) > 1) and (s[1] = '"') and (s[Length(s)] <> '"') then
      Delete(s, 1, 1);
    //WriteLn('"', s, '"');
  end
  else if (ParamStr(1) = '/ll') or (ParamStr(1) = '-ll') then
  begin
    sl := TStringList.Create();
    s := '';
    try
      //WriteLn(ParamStr(2));
      sl.LoadFromFile(ParamStr(2));
      //Write(sl.Text);
      while sl.Count > 0 do
      begin
        s := s+'load "'+sl[0]+'";';
        sl.Delete(0);
      end;
    except
    end;
    sl.Free();
  end
  else if ParamCount() > 0 then
  begin
    s := '';
    for f := 1 to ParamCount() do
    begin
      s := s+'load "'+ParamStr(f)+'";';
    end;
  end;

  try
    ConExecute(s);
  except on e: Exception do
    WriteLn('***ERROR ', e.ClassName, ': ', e.Message);
  end;
  //if ParamCount() < 1 then SetCurrentDir('e:\zx\_');

  ALispEvalStr('(load "init/latest_init")');
  //WriteLn;

  //ALispEvalStr('(snap-unload)');
  //WriteLn('RUN!');
  //UpdateWindow(emuHWnd);
  PostMessage(HWND_BROADCAST, kOnOffMsg, 0, 0); // turn off the Klock

  if (ParamCount() > 0) and (logoWH <> 0) then PostMessage(logoWH, WM_CLOSE, 0, 0);
  try
    while not EmuProcessMessages() do
    begin
      EmuExec();
      if not emuMaxSpeed and (emuSpeedFactor <= 3.0) then Sleep(1);
    end;

    emuDisks.disks[0].Eject();
    emuDisks.disks[1].Eject();
    emuDisks.disks[2].Eject();
    emuDisks.disks[3].Eject();
  finally
    PostMessage(HWND_BROADCAST, kOnOffMsg, 1, 0); // turn on the Klock
    EmuUnlockMouse();
    EmuShowMouse();
  end;
end.
