// DarkSpecter ZX Spectum Emulator
// coded by Ketmar // Vampire Avalon (psyc://ketmar.no-ip.org/~Ketmar)
// Understanding is not required. Only obedience.
//
// This program is free software. It comes without any warranty, to
// the extent permitted by applicable law. You can redistribute it
// and/or modify it under the terms of the Do What The Fuck You Want
// To Public License, Version 2, as published by Sam Hocevar. See
// http://sam.zoy.org/wtfpl/COPYING for more details.
//
// locking & unlocking the mouse
//
unit dspEmuMouseU;

interface

uses
  Windows;


var
  emuMouseLocked: Boolean = false;
  emuMouseHidden: Boolean = false;
  emuHWnd: HWND = 0;
    // handle of the main window
  emuFullScreen: Boolean = false;


procedure EmuLockMouse ();
procedure EmuUnlockMouse ();

procedure EmuHideMouse ();
procedure EmuShowMouse ();


implementation


procedure EmuHideMouse ();
begin
  if emuMouseHidden then exit;
  ShowCursor(false);
  emuMouseHidden := true;
end;

procedure EmuShowMouse ();
begin
  if not emuMouseHidden then exit;
  ShowCursor(true);
  emuMouseHidden := false;
end;

procedure EmuLockMouse ();
var
  r: TRect;
begin
  EmuHideMouse();
  if emuMouseLocked then exit;
  emuMouseLocked := true;

  GetWindowRect(emuHWnd, r);
  if not emuFullScreen then
  begin
    Inc(r.Left, GetSystemMetrics(SM_CXFRAME));
    Dec(r.Right, GetSystemMetrics(SM_CXFRAME));
    Inc(r.Top, GetSystemMetrics(SM_CYFRAME)+GetSystemMetrics(SM_CYCAPTION));
    Dec(r.Bottom, GetSystemMetrics(SM_CYFRAME));
  end;
  SetCursorPos(r.Left+(r.Right-r.Left) div 2, r.Top+(r.Bottom-r.Top) div 2);
  ClipCursor(@r);
end;

procedure EmuUnlockMouse ();
begin
  if not emuFullScreen then EmuShowMouse();
  ClipCursor(nil);
  if not emuMouseLocked then exit;
  emuMouseLocked := false;
end;


end.
