// copy 8-bit line for 15/16/24/32 bit modes
// in: shiftr, shiftg, shiftb
//     scaler, scaleg, scaleb
//     eax: src
//     edx: dest
// conditional: SCALE2X, OUT32BIT, OUT24BIT, COLORSCALEDx, DOSHIFTx
asm
  push ebx
  push esi
  push edi

  mov  esi,eax
  mov  edi,edx

  mov   ecx,320   // width
@pixelloop:
  xor   eax,eax
  lodsb
  // load rgb address
  lea   edx,dword ptr [offset vsCurrentPalette+eax*4]

  // build output word; result: eax
  // red
  movzx eax,[edx]
  inc   edx
  {$IFDEF COLORSCALEDR}
  shr   eax,scaler
  {$ENDIF}
  {$IFDEF DOSHIFTR}
  shl   eax,shiftr
  {$ENDIF}
  // green
  movzx ebx,[edx]
  inc   edx
  {$IFDEF COLORSCALEDG}
  shr   ebx,scaleg
  {$ENDIF}
  {$IFDEF DOSHIFTG}
  shl   ebx,shiftg
  {$ENDIF}
  or    eax,ebx
  // blue
  movzx ebx,[edx]
  inc   edx
  {$IFDEF COLORSCALEDB}
  shr   ebx,scaleb
  {$ENDIF}
  {$IFDEF DOSHIFTB}
  shl   ebx,shiftb
  {$ENDIF}
  or    eax,ebx
  // skip align byte
  //inc   edx

  // output value
  {$IFDEF OUT32BIT}
    // 32-bit; the easiest case %-)
    stosd
   {$IFDEF SCALE2X}stosd{$ENDIF}
  {$ENDIF}
  {$IFDEF OUT24BIT}
    // 24-bit
   {$IFDEF SCALE2X}
    mov  ebx,eax
    stosw
    shr  eax,16
    stosb
    mov  eax,ebx
   {$ENDIF}
    stosw
    shr  eax,16
    stosb
  {$ENDIF}
  {$IFDEF OUT16BIT}
    // 15/16-bit, easy case
    stosw
    {$IFDEF SCALE2X}stosw{$ENDIF}
  {$ENDIF}
  loop  @pixelloop

  pop  edi
  pop  esi
  pop  ebx
end;
